/*
* Classic Space Wars
*
* Copyright 1997, The Plastic Factory, All rights reserved
*
* Author: Peter Hirschberg
*
* Written for Microsoft Visual C++ version 5.0
*
* The released version of the CLASSIC SPACE WARS APPLICATION for Windows 95 is
* available from our website at http://www.advancedaerials.com/plastic/index.htm .
* The current version of this SOURCE CODE is also available here.
*
*
*
* License agreement:
*
* This SOURCE CODE may be distributed in unmodified form to any medium.
*
* The SOURCE CODE or the CLASSIC SPACE WARS APPLICATION may not be sold,
* or sold as a part of a commercial package without the express written
* permission of The Plastic Factory (hippies@mnsinc.com).
* This includes shareware.
*
* *** MODIFIED VERSIONS OF THIS SOURCE CODE OR THE SPACE WARS APPLICATION MAY NOT
* *** BE PUBLICLY REDISTRIBUTED WITHOUT AUTHOR APPROVAL!! (hippies@mnsinc.com).
* This includes distributing via a publicly accessible LAN.
* The Plastic Factory retains all rights to this SOURCE CODE,
* and the CLASSIC SPACE WARS APPLICATION.
*
* The Plastic Factory, and Peter Hirschberg will not be held responsible for
* any damage done by the use of this SOURCE CODE,
* or the CLASSIC SPACE WARS APPLICATION.
* It is purely "as-is".
*
* If you find problems with this SOURCE CODE,
* or make any additions/modifications/improvements,
* PLEASE EMAIL THE PLASTIC FACTORY so that they can be propogated to the
* installed base of CLASSIC SPACE WARS users.
* 
* Thank you!
* 
* Peter Hirschberg
* 
* The Plastic Factory
* Email : hippies@mnsinc.com
* Website : http://www.advancedaerials.com/plastic/index.htm
*
*/
 

#include <windows.h>
#include "sin_cos.h"



// defines
#define MAX_VERTS					50
#define MAX_LINES					40
#define MAX_MISSILES				4
#define NUM_OBJECTS					(4+4+1+1+(MAX_MISSILES*2)+1)
#define MAX_DEBRIS					(MAX_LINES*2)

#define OBJSTATE_NORMAL				1
#define OBJSTATE_DAMAGED			2
#define OBJSTATE_EXPLODING			3
#define OBJSTATE_DESTROYED			4
#define OBJSTATE_HYPERSPACE			5
#define OBJSTATE_HIDDEN				6

#define OBJID_UNDEF					0
#define OBJID_PLAYER1FRONT			1
#define OBJID_PLAYER1RIGHT			2
#define OBJID_PLAYER1LEFT			3
#define OBJID_PLAYER2FRONT			4
#define OBJID_PLAYER2RIGHT			5
#define OBJID_PLAYER2LEFT			6
#define OBJID_MISSILE				7
#define OBJID_ASTEROID				8
#define OBJID_FLAME					9
#define OBJID_DEBRIS				10
#define OBJID_SUNA					11
#define OBJID_SUNB					12
#define OBJID_TEXT					13

#define EDGEACT_WRAP				0
#define EDGEACT_BOUNCE				1
#define EDGEACT_EXPANDED			2

// forward ref.
class Object2d;
class shipObject2d;

// useful structures
class INTPOINT{
public:
	int		x, y;
	// overloaded operators
	INTPOINT operator + (INTPOINT pt2){
	INTPOINT resultPt;
		resultPt.x = (this->x) + (pt2.x);
		resultPt.y = (this->y) + (pt2.y);
		return resultPt;
	}
	INTPOINT operator - (INTPOINT pt2){
	INTPOINT resultPt;
		resultPt.x = (this->x) - (pt2.x);
		resultPt.y = (this->y) - (pt2.y);
		return resultPt;
	}
	INTPOINT operator * (INTPOINT pt2){
	INTPOINT resultPt;
		resultPt.x = (this->x) * (pt2.x);
		resultPt.y = (this->y) * (pt2.y);
		return resultPt;
	}
	INTPOINT operator / (INTPOINT pt2){
	INTPOINT resultPt;
		resultPt.x = (this->x) / (pt2.x);
		resultPt.y = (this->y) / (pt2.y);
		return resultPt;
	}
	void operator += (INTPOINT pt2){
		(this->x)+=pt2.x;
		(this->y)+=pt2.y;
	}
	void operator -= (INTPOINT pt2){
		(this->x)-=pt2.x;
		(this->y)-=pt2.y;
	}
	void operator *= (INTPOINT pt2){
		(this->x)*=pt2.x;
		(this->y)*=pt2.y;
	}
	void operator /= (INTPOINT pt2){
		(this->x)/=pt2.x;
		(this->y)/=pt2.y;
	}

	INTPOINT operator + (float val){
	INTPOINT resultPt;
		resultPt.x = (this->x) + val;
		resultPt.y = (this->y) + val;
		return resultPt;
	}
	INTPOINT operator - (float val){
	INTPOINT resultPt;
		resultPt.x = (this->x) - val;
		resultPt.y = (this->y) - val;
		return resultPt;
	}
	INTPOINT operator * (float val){
	INTPOINT resultPt;
		resultPt.x = (this->x) * val;
		resultPt.y = (this->y) * val;
		return resultPt;
	}
	INTPOINT operator / (float val){
	INTPOINT resultPt;
		resultPt.x = (this->x) / val;
		resultPt.y = (this->y) / val;
		return resultPt;
	}
	void operator += (float val){
		(this->x)+=val;
		(this->y)+=val;
	}
	void operator -= (float val){
		(this->x)-=val;
		(this->y)-=val;
	}
	void operator *= (float val){
		(this->x)*=val;
		(this->y)*=val;
	}
	void operator /= (float val){
		(this->x)/=val;
		(this->y)/=val;
	}

	INTPOINT operator + (int val){
	INTPOINT resultPt;
		resultPt.x = (this->x) + val;
		resultPt.y = (this->y) + val;
		return resultPt;
	}
	INTPOINT operator - (int val){
	INTPOINT resultPt;
		resultPt.x = (this->x) - val;
		resultPt.y = (this->y) - val;
		return resultPt;
	}
	INTPOINT operator * (int val){
	INTPOINT resultPt;
		resultPt.x = (this->x) * val;
		resultPt.y = (this->y) * val;
		return resultPt;
	}
	INTPOINT operator / (int val){
	INTPOINT resultPt;
		resultPt.x = (this->x) / val;
		resultPt.y = (this->y) / val;
		return resultPt;
	}
	void operator += (int val){
		(this->x)+=val;
		(this->y)+=val;
	}
	void operator -= (int val){
		(this->x)-=val;
		(this->y)-=val;
	}
	void operator *= (int val){
		(this->x)*=val;
		(this->y)*=val;
	}
	void operator /= (int val){
		(this->x)/=val;
		(this->y)/=val;
	}


};

class FLOATPOINT{
public:
	float	x, y;
	// overloaded operators
	FLOATPOINT operator + (FLOATPOINT pt2){
	FLOATPOINT resultPt;
		resultPt.x = (this->x) + (pt2.x);
		resultPt.y = (this->y) + (pt2.y);
		return resultPt;
	}
	FLOATPOINT operator - (FLOATPOINT pt2){
	FLOATPOINT resultPt;
		resultPt.x = (this->x) - (pt2.x);
		resultPt.y = (this->y) - (pt2.y);
		return resultPt;
	}
	FLOATPOINT operator * (FLOATPOINT pt2){
	FLOATPOINT resultPt;
		resultPt.x = (this->x) * (pt2.x);
		resultPt.y = (this->y) * (pt2.y);
		return resultPt;
	}
	FLOATPOINT operator / (FLOATPOINT pt2){
	FLOATPOINT resultPt;
		resultPt.x = (this->x) / (pt2.x);
		resultPt.y = (this->y) / (pt2.y);
		return resultPt;
	}
	void operator += (FLOATPOINT pt2){
		(this->x)+=pt2.x;
		(this->y)+=pt2.y;
	}
	void operator -= (FLOATPOINT pt2){
		(this->x)-=pt2.x;
		(this->y)-=pt2.y;
	}
	void operator *= (FLOATPOINT pt2){
		(this->x)*=pt2.x;
		(this->y)*=pt2.y;
	}
	void operator /= (FLOATPOINT pt2){
		(this->x)/=pt2.x;
		(this->y)/=pt2.y;
	}


	FLOATPOINT operator + (float val){
	FLOATPOINT resultPt;
		resultPt.x = (this->x) + val;
		resultPt.y = (this->y) + val;
		return resultPt;
	}
	FLOATPOINT operator - (float val){
	FLOATPOINT resultPt;
		resultPt.x = (this->x) - val;
		resultPt.y = (this->y) - val;
		return resultPt;
	}
	FLOATPOINT operator * (float val){
	FLOATPOINT resultPt;
		resultPt.x = (this->x) * val;
		resultPt.y = (this->y) * val;
		return resultPt;
	}
	INTPOINT operator / (float val){
	INTPOINT resultPt;
		resultPt.x = (this->x) / val;
		resultPt.y = (this->y) / val;
		return resultPt;
	}
	void operator += (float val){
		(this->x)+=val;
		(this->y)+=val;
	}
	void operator -= (float val){
		(this->x)-=val;
		(this->y)-=val;
	}
	void operator *= (float val){
		(this->x)*=val;
		(this->y)*=val;
	}
	void operator /= (float val){
		(this->x)/=val;
		(this->y)/=val;
	}

	FLOATPOINT operator + (int val){
	FLOATPOINT resultPt;
		resultPt.x = (this->x) + val;
		resultPt.y = (this->y) + val;
		return resultPt;
	}
	FLOATPOINT operator - (int val){
	FLOATPOINT resultPt;
		resultPt.x = (this->x) - val;
		resultPt.y = (this->y) - val;
		return resultPt;
	}
	FLOATPOINT operator * (int val){
	FLOATPOINT resultPt;
		resultPt.x = (this->x) * val;
		resultPt.y = (this->y) * val;
		return resultPt;
	}
	FLOATPOINT operator / (int val){
	FLOATPOINT resultPt;
		resultPt.x = (this->x) / val;
		resultPt.y = (this->y) / val;
		return resultPt;
	}
	void operator += (int val){
		(this->x)+=val;
		(this->y)+=val;
	}
	void operator -= (int val){
		(this->x)-=val;
		(this->y)-=val;
	}
	void operator *= (int val){
		(this->x)*=val;
		(this->y)*=val;
	}
	void operator /= (int val){
		(this->x)/=val;
		(this->y)/=val;
	}


};

class FLOATLINE{
public:
	FLOATPOINT	from;
	FLOATPOINT	to;
};

class AREARECT{
public:
	int		left,top,right,bottom;
};


// externs
extern	unsigned	int ViewPort_Width;
extern	unsigned	int ViewPort_Height;
extern	float			ScreenXScaler;
extern	float			ScreenYScaler;
extern	int				ScreenOffLeftMargin;
extern	int				ScreenOffTopMargin;
extern	int				ScreenOffRightMargin;
extern	int				ScreenOffBottomMargin;
extern	int				ScreenInLeftMargin;
extern	int				ScreenInTopMargin;
extern	int				ScreenInRightMargin;
extern	int				ScreenInBottomMargin;


// exports
extern UINT				shipPlayer1NumVerts;
extern FLOATPOINT		shipPlayer1Verts[];
extern UINT				shipPlayer1FrontNumLines;
extern INTPOINT			shipPlayer1FrontLines[];
extern UINT				shipPlayer1RightNumLines;
extern INTPOINT			shipPlayer1RightLines[];
extern UINT				shipPlayer1LeftNumLines;
extern INTPOINT			shipPlayer1LeftLines[];

extern UINT				shipPlayer2NumVerts;
extern FLOATPOINT		shipPlayer2Verts[];
extern UINT				shipPlayer2FrontNumLines;
extern INTPOINT			shipPlayer2FrontLines[];
extern UINT				shipPlayer2RightNumLines;
extern INTPOINT			shipPlayer2RightLines[];
extern UINT				shipPlayer2LeftNumLines;
extern INTPOINT			shipPlayer2LeftLines[];

extern UINT				asteroidNumVerts;
extern FLOATPOINT		asteroidVerts[];
extern UINT				asteroidNumLines;
extern INTPOINT			asteroidLines[];
extern UINT				flamePlayer1NumVerts;
extern FLOATPOINT		flamePlayer1Verts[];
extern UINT				flamePlayer1NumLines;
extern INTPOINT			flamePlayer1Lines[];
extern UINT				flamePlayer2NumVerts;
extern FLOATPOINT		flamePlayer2Verts[];
extern UINT				flamePlayer2NumLines;
extern INTPOINT			flamePlayer2Lines[];
extern UINT				sunNumVerts;
extern FLOATPOINT		sunVerts[];
extern UINT				sunANumLines;
extern INTPOINT			sunALines[];
extern UINT				sunBNumLines;
extern INTPOINT			sunBLines[];
extern UINT				missileNumVerts;
extern FLOATPOINT		missileVerts[];
extern UINT				missileNumLines;
extern INTPOINT			missileLines[];
extern UINT				gameoverNumVerts;
extern FLOATPOINT		gameoverVerts[];
extern UINT				gameoverNumLines;
extern INTPOINT			gameoverLines[];

extern float shipPlayer1Scale;
extern float shipPlayer2Scale;
extern float asteroidScale;
extern float flamePlayer1Scale;
extern float flamePlayer2Scale;
extern float missileScale;
extern float sunScale;
extern float gameoverScale;

extern Object2d shipPlayer1Front;
extern Object2d shipPlayer1Right;
extern Object2d shipPlayer1Left;
extern Object2d shipPlayer2Front;
extern Object2d shipPlayer2Right;
extern Object2d shipPlayer2Left;
extern Object2d asteroid;
extern Object2d flamePlayer1;
extern Object2d flamePlayer2;
extern Object2d sunA;
extern Object2d sunB;
extern Object2d	player1Missiles[];
extern Object2d	player2Missiles[];
extern Object2d	debris[];
extern Object2d gameoverObj;

extern shipObject2d shipPlayer1;
extern shipObject2d shipPlayer2;

AREARECT AreaRectUnion(AREARECT rect1, AREARECT rect2);
BOOL DoRectsIntersect(AREARECT rect1, AREARECT rect2);
FLOATPOINT RotatePoint(FLOATPOINT oldPoint, int angle);
INTPOINT MakeIntPoint(int x, int y);
FLOATPOINT MakeFloatPoint(float x, float y);
AREARECT MakeAreaRect(int left, int top, int right, int bottom);
BOOL LineRectIntersect(FLOATPOINT fromPt, FLOATPOINT toPt, AREARECT rect);



/***********************************************************************
*         *** class Object2d ***
************************************************************************
*
* Description:
*
* Parameters:
*
* Returns:
*
************************************************************************/
class Object2d{
public:
	UINT			m_objId;						// type of object
	BOOL			m_visible;						// visibility flag
	BOOL			m_eraseMe;						// erase flag
	BOOL			m_prevNotVis;					// previously hidden flag
	UINT			m_state;						// object state
	UINT			m_numVerts;
	FLOATPOINT		m_verts[MAX_VERTS];
	UINT			m_numLines;
	INTPOINT		m_lines[MAX_LINES];
	FLOATPOINT		m_pos;							// screen position
	FLOATPOINT		m_posOld;
	int				m_rotation;						// object angle
	float			m_spin;							// object spin rate
	float			m_scale;						// object scale
	int				m_brightness;					// object brightness
	int				m_flashbright;					// flash brightness
	float			m_flashtimer;					// length of flash
	FLOATPOINT		m_speed;						// movement speed
	AREARECT		m_invRect;						// area of the screen invalidated by the object
	AREARECT		m_invRectOld;
	UINT			m_edgeAct;						// screen edge action
	float			m_lifetime;						// used for missiles and explosion debris...

public:
	inline void Init(UINT objId, UINT numVerts, FLOATPOINT verts[], UINT numLines, INTPOINT lines[]){
		// init the member vars and load the object data
		m_objId = objId;
		m_visible = FALSE;
		m_eraseMe = FALSE;
		m_prevNotVis = TRUE;
		m_state = OBJSTATE_NORMAL;
		m_lifetime = 0.0;
		m_scale = 1.0;
		m_pos = MakeFloatPoint(0,0);
		m_posOld = MakeFloatPoint(0,0);
		m_invRect = MakeAreaRect(0,0,0,0);
		m_invRectOld = MakeAreaRect(0,0,0,0);
		m_rotation = 0;
		m_brightness = 0;
		m_flashbright = 0;
		m_flashtimer = 0.0;
		m_edgeAct = EDGEACT_WRAP;
		m_numVerts = numVerts;
		for (int i=0; i < numVerts; i++){
			m_verts[i] = verts[i];
		}
		m_numLines = numLines;
		for (i=0; i < numLines; i++){
			m_lines[i] = lines[i];
		}
	}

	inline	UINT ObjectID(void){ return m_objId; }
	inline	void ObjectID(UINT id){ m_objId = id; }

	inline	UINT State(void){ return m_state; }
	inline	void State(UINT state){ m_state = state; }

	inline	float Lifetime(void){ return m_lifetime; }
	inline	void Lifetime(float lifetime){ m_lifetime = lifetime; }

	inline	void Flash(int bright, float timer){ 
		m_flashbright = bright;
		m_flashtimer = timer;
	}

	inline	UINT EdgeAction(void){ return m_edgeAct; }
	inline	void EdgeAction(UINT act){ m_edgeAct = act; }

	inline	BOOL Visible(void){ return m_visible; }
	inline	void Visible(BOOL visible){ 
		m_visible = visible;
		if (!m_visible){
			m_eraseMe = TRUE;
			m_prevNotVis = TRUE;
		} else {
			m_eraseMe = FALSE;
		}
	}

	inline int Brightness(void){ return m_brightness; }
	inline void Brightness(int brightness){ m_brightness = brightness; }

	inline FLOATPOINT Speed(void){ return m_speed; }
	inline void Speed(FLOATPOINT speed){ m_speed = speed; }

	inline float Scale(void){ return m_scale; }
	inline void Scale(float scale){ m_scale = scale; }

	inline FLOATPOINT Position(void){ return m_pos; }
	inline void Position(FLOATPOINT pos){
		m_posOld = m_pos;
		m_pos = pos;
	}

	inline int Rotate(void){ return m_rotation; }
	inline void Rotate(int angle){
		if (m_state == OBJSTATE_NORMAL){
			angle %= NUMBER_OF_DEGREES;
			m_rotation = angle;
			if (m_rotation < 0){ m_rotation += NUMBER_OF_DEGREES; }
			else if (m_rotation >= NUMBER_OF_DEGREES){ m_rotation -= NUMBER_OF_DEGREES; }
		}
	}

	inline float Spin(void){ return m_spin; }
	inline void Spin(float spin){ m_spin = spin; }

	inline BOOL UpdatePosition(float delta){ 
		UINT edgeAct;
		BOOL hitEdge = FALSE;

		if (m_lifetime){
			m_lifetime -= delta;
			if (m_lifetime <= (float)0.0){
				m_lifetime = 0.0;
				m_eraseMe = TRUE;
				m_prevNotVis = TRUE;
				m_visible = FALSE;
			}
		}

		if (m_flashtimer){
			m_flashtimer -= delta;
			if (m_flashtimer <= (float)0.0){
				m_flashtimer = 0.0;
			}
		}

		if ((m_visible) && (m_state <= OBJSTATE_DAMAGED)){
			// store the previous position for posterity
			m_posOld = m_pos;	
			// move the object
			m_pos.x += m_speed.x * delta;
			m_pos.y += m_speed.y * delta;
			// check for screen wrap around...
			if (m_objId == OBJID_ASTEROID){
				edgeAct = EDGEACT_WRAP;
			} else {
				edgeAct = m_edgeAct;
			}
			switch (edgeAct){
				default:
				case EDGEACT_WRAP:
					if ((m_pos.x * ScreenXScaler) > ViewPort_Width+ScreenOffRightMargin){
						m_pos.x = ScreenInLeftMargin;
						m_pos.x /= ScreenXScaler;
						hitEdge = TRUE;
					}
					else if ((m_pos.x * ScreenXScaler) < -ScreenOffLeftMargin){
						m_pos.x = (ViewPort_Width-ScreenInRightMargin);
						m_pos.x /= ScreenXScaler;
						hitEdge = TRUE;
					}
					if ((m_pos.y * ScreenYScaler) > ViewPort_Height+ScreenOffBottomMargin){
						m_pos.y = ScreenInTopMargin;
						m_pos.y /= ScreenYScaler;
						hitEdge = TRUE;
					}
					else if ((m_pos.y * ScreenYScaler) < -ScreenOffTopMargin){
						m_pos.y = (ViewPort_Height-ScreenInBottomMargin);
						m_pos.y /= ScreenYScaler;
						hitEdge = TRUE;
					}
					break;
				case EDGEACT_BOUNCE:
					if ((m_pos.x * ScreenXScaler) > ViewPort_Width-ScreenOffRightMargin){
						Rotate(NUMBER_OF_DEGREES-m_rotation);
						m_speed.x = -m_speed.x;
						m_pos.x = (ViewPort_Width-ScreenOffRightMargin) + m_speed.x;
						m_pos.x /= ScreenXScaler;
						hitEdge = TRUE;
					}
					else if ((m_pos.x * ScreenXScaler) < ScreenOffLeftMargin){
						Rotate(NUMBER_OF_DEGREES-m_rotation);
						m_speed.x = -m_speed.x;
						m_pos.x = ScreenOffLeftMargin + m_speed.x;
						m_pos.x /= ScreenXScaler;
						hitEdge = TRUE;
					}
					if ((m_pos.y * ScreenYScaler) > ViewPort_Height-ScreenOffBottomMargin){
						Rotate((NUMBER_OF_DEGREES-m_rotation)-HALF_ROTATION);
						m_speed.y = -m_speed.y;
						m_pos.y = (ViewPort_Height-ScreenOffBottomMargin) + m_speed.y;
						m_pos.y /= ScreenYScaler;
						hitEdge = TRUE;
					}
					else if ((m_pos.y * ScreenYScaler) < ScreenOffTopMargin){
						Rotate((NUMBER_OF_DEGREES-m_rotation)-HALF_ROTATION);
						m_speed.y = -m_speed.y;
						m_pos.y = ScreenOffTopMargin + m_speed.y;
						m_pos.y /= ScreenYScaler;
						hitEdge = TRUE;
					}
					break;
			}
			// spin the object...
			if (m_spin > 0.0){
					m_rotation += m_spin * delta;
					if (m_rotation < 0){ m_rotation += NUMBER_OF_DEGREES; }
					else if (m_rotation >= NUMBER_OF_DEGREES){ m_rotation -= NUMBER_OF_DEGREES; }
			}
		}
		return hitEdge;
	}


	inline AREARECT GetObjectRect(void){ return m_invRect; }
	inline AREARECT GetInvRect(void){
		return AreaRectUnion(m_invRect, m_invRectOld);
	}


	void EraseObject(HDC);
	void DrawObject(HDC);

};


/***********************************************************************
*         *** class shipObject2d ***
************************************************************************
*
* Description:
*
* the ships are broken up into three separate objects
* - front
* - right
* - left
* this is to facilitate partial ship damage
* the shipObject2d class is just a convenient
* way to group the 'pieces' together into a
* common interface
*
* Parameters:
*
* Returns:
*
************************************************************************/
class shipObject2d{
public:

	Object2d *front;
	Object2d *right;
	Object2d *left;

inline void shipPosition(FLOATPOINT pos){
		front->Position(pos);
		right->Position(pos);
		left->Position(pos);
	}
inline FLOATPOINT shipPosition(void){
		return (front->Position());
	}

inline void shipRotate(int angle){
		front->Rotate(angle);
		right->Rotate(angle);
		left->Rotate(angle);
	}
inline int shipRotate(void){
		return (front->Rotate());
	}

inline void shipSpeed(FLOATPOINT speed){
		front->Speed(speed);
		right->Speed(speed);
		left->Speed(speed);
	}
inline FLOATPOINT shipSpeed(void){
		return (front->Speed());
	}

inline void shipVisible(BOOL visible){
		front->Visible(visible);
		right->Visible(visible);
		left->Visible(visible);
	}
inline BOOL shipVisible(void){
		return (front->Visible() || right->Visible() || left->Visible());
	}

inline void shipState(UINT state){
		front->State(state);
		right->State(state);
		left->State(state);
	}
inline UINT shipState(void){
	UINT frontState, rightState, leftState;

		frontState = front->State();
		rightState = right->State();
		leftState = left->State();

		if ((frontState == rightState)
			&& (frontState == leftState)){
			// states are equal...
			return frontState;
		} else {
			// not equal, must be damaged
			return OBJSTATE_DAMAGED;
		}
	}

inline void shipSpin(float spin){ 
		front->Spin(spin);
		right->Spin(spin);
		left->Spin(spin);
	}
inline float shipSpin(void){
		return (front->Spin());
	}

inline void shipBrightness(int brightness){
		front->Brightness(brightness);
		right->Brightness(brightness);
		left->Brightness(brightness);
	}
inline int shipBrightness(void){
		return (front->Brightness());
	}

inline void shipScale(float scale){
		front->Scale(scale);
		right->Scale(scale);
		left->Scale(scale);
	}
inline float shipScale(void){
		return (front->Scale());
	}

inline void shipLifetime(float lifetime){
		front->Lifetime(lifetime);
		right->Lifetime(lifetime);
		left->Lifetime(lifetime);
	}
inline float shipLifetime(void){
		return (front->Lifetime());
	}

inline void shipFlash(int bright, float timer){
		front->Flash(bright, timer);
		right->Flash(bright, timer);
		left->Flash(bright, timer);
	}

inline void Align(){
		// align right and left with the front...
		right->Position(front->Position());
		left->Position(front->Position());
		right->Rotate(front->Rotate());
		left->Rotate(front->Rotate());
	}		

};




