/*
* Classic Space Wars
*
* Copyright 1997, The Plastic Factory, All rights reserved
*
* Author: Peter Hirschberg
*
* Written for Microsoft Visual C++ version 5.0
*
* The released version of the CLASSIC SPACE WARS APPLICATION for Windows 95 is
* available from our website at http://www.advancedaerials.com/plastic/index.htm .
* The current version of this SOURCE CODE is also available here.
*
*
*
* License agreement:
*
* This SOURCE CODE may be distributed in unmodified form to any medium.
*
* The SOURCE CODE or the CLASSIC SPACE WARS APPLICATION may not be sold,
* or sold as a part of a commercial package without the express written
* permission of The Plastic Factory (hippies@mnsinc.com).
* This includes shareware.
*
* *** MODIFIED VERSIONS OF THIS SOURCE CODE OR THE SPACE WARS APPLICATION MAY NOT
* *** BE PUBLICLY REDISTRIBUTED WITHOUT AUTHOR APPROVAL!! (hippies@mnsinc.com).
* This includes distributing via a publicly accessible LAN.
* The Plastic Factory retains all rights to this SOURCE CODE,
* and the CLASSIC SPACE WARS APPLICATION.
*
* The Plastic Factory, and Peter Hirschberg will not be held responsible for
* any damage done by the use of this SOURCE CODE,
* or the CLASSIC SPACE WARS APPLICATION.
* It is purely "as-is".
*
* If you find problems with this SOURCE CODE,
* or make any additions/modifications/improvements,
* PLEASE EMAIL THE PLASTIC FACTORY so that they can be propogated to the
* installed base of CLASSIC SPACE WARS users.
* 
* Thank you!
* 
* Peter Hirschberg
* 
* The Plastic Factory
* Email : hippies@mnsinc.com
* Website : http://www.advancedaerials.com/plastic/index.htm
*
*/
 


#define STRICT

// includes
#include <windows.h>
#include <stdio.h>
#include <time.h>
#include <math.h>
#include "resource.h"
#include "sin_cos.h"
#include "object.h"
#include "random.h"
#include "digits.h"


// defines
#define CLOCK_TICK			54	// hardware timer freq. (ms)
#define VIEWPORT_WIDTH		640
#define VIEWPORT_HEIGHT		480
#define VIEWPORTMINX		50
#define VIEWPORTMINY		200
#define MAX_BRIGHT			255
#define MIN_BRIGHT			0
#define NORM_BRIGHT			150
#define MINSTARBRIGHT		MIN_BRIGHT
#define MAXSTARBRIGHT		MAX_BRIGHT
#define SUNVISIBLE			TRUE
#define SUNPRESENT			TRUE
#define SUNSPIN				0
#define SUNXPOS				((float)VIEWPORT_WIDTH/(float)2)
#define SUNYPOS				((float)VIEWPORT_HEIGHT/(float)2)
#define SUNGRAVITY			-1000
#define ATTRACTMODE_SUNGRAVITY	-500
#define SHIPPLAYER1STARTFROMMARGIN	7
#define SHIPPLAYER2STARTFROMMARGIN	7
#define SHIPPLAYER1STARTROT			(270*4)
#define SHIPPLAYER2STARTROT			(90*4)
#define ASTEROIDSTARTROT			(0*4)
#define SHIPPLAYER1BRIGHTNESS		NORM_BRIGHT
#define SHIPPLAYER2BRIGHTNESS		NORM_BRIGHT
#define ASTEROIDROTSPEED			(0*4)
#define FLAMEPLAYER1BRIGHTNESS		MAX_BRIGHT
#define FLAMEPLAYER2BRIGHTNESS		MAX_BRIGHT
#define SHIPPLAYER1HYPERTIME		20	
#define SHIPPLAYER2HYPERTIME		20
#define REENTRYMAXPROB				75
#define REENTRYMINPROB				20
#define REENTRYPROBDECREASE			10
#define EXPLODEINITIALBRIGHTNESS	MAX_BRIGHT
#define EXPLODESECONDARYBRIGHTNESS	NORM_BRIGHT
#define EXPLODELIFETIME				75
#define EXPLOSIONFADE				0
#define	EXPLODEPAUSETIME			15
#define SOUNDENABLED				TRUE
#define MUSICENABLED				TRUE
#define	SCREENOFFLEFTMARGIN			10
#define SCREENOFFTOPMARGIN			10
#define SCREENOFFRIGHTMARGIN		10
#define SCREENOFFBOTTOMMARGIN		10
#define	SCREENINLEFTMARGIN			10
#define SCREENINTOPMARGIN			10
#define SCREENINRIGHTMARGIN			10
#define SCREENINBOTTOMMARGIN		10
#define MISSILEBRIGHTNESS			MAX_BRIGHT
#define PLAYER1SIMULMISSILES		4
#define PLAYER2SIMULMISSILES		4
#define MOMENTUM					TRUE
#define DRAG						FALSE
#define DEBRISSPINRANGE				0 // was 10
#define DEBRISDIRECTIONVAR			(5*4) // was 25*4
#define DEBRISMAXSPEED				(1) // was .75
#define ASTEROIDFREQUENCY			555  
#define ASTEROIDSPEED				1
#define ASTEROIDBRIGHTNESS			MAX_BRIGHT
#define SHIPPLAYER1MASS				2
#define SHIPPLAYER2MASS				2
#define ASTEROIDMASS				3
#define MISSILEMASS					(.75)
#define DEBRISMASS					4
#define ROUNDINITIALTIME			90
#define PLAYER1FUELCONSUMPTION		(.5)
#define PLAYER2FUELCONSUMPTION		(.5)
#define DAMAGEFLASHTIME				5
#define DAMAGEFLASHBRIGHTNESS		MAX_BRIGHT
#define SUNDISTCLAMP				(20.0)
#define FRAGTIME					7
#define ATTRACTTIME					20
#define ATTRACTMODEGRACTIME			30
#define EDGEMODE					EDGEACT_WRAP
#define INVERSEGRAVITY				FALSE
#define SUNMINBRIGHT				NORM_BRIGHT
#define SUNMAXBRIGHT				MAX_BRIGHT
#define SUNANIMATERATE				15
#define SHIPROTSPEED				(10*4)
#define SHIPMAXSPEED				8
#define SHIPACCEL					.5
#define SHIPDECEL					0.1001
#define INITIALFUELAMOUNT			250
#define INITIALNUMMISSILES			18
#define MISSILELIFETIME				45
#define MISSILESPEED				10


#define KEYDEFPLAYER1LEFT			'Z'
#define KEYDEFPLAYER1RIGHT			'X'
#define KEYDEFPLAYER1FIRE			'B'
#define KEYDEFPLAYER1THRUST			'V'
#define KEYDEFPLAYER1HYPER			'C'
#define KEYDEFPLAYER2LEFT			'N'
#define KEYDEFPLAYER2RIGHT			'M'
#define KEYDEFPLAYER2FIRE			''
#define KEYDEFPLAYER2THRUST			''
#define KEYDEFPLAYER2HYPER			''
#define KEYDEFRESETGAME				' '
#define	KEYDEFMINIMIZE				0x1b
#define	KEYDEFPAUSE					'P'
#define KEYDEFSTARTGAME				'S'


// externals
extern char szAppName[];
extern char szAppCaption[];
extern char szVersion[];
extern char szContactInfo[];
extern unsigned int	digitBrightness;


// global            
HINSTANCE HInstance;	// handle to current program instance
// ------- begin user vars --------
unsigned	int ViewPort_Width = VIEWPORT_WIDTH;
unsigned	int ViewPort_Height = VIEWPORT_HEIGHT;
unsigned	int ViewPortMinX = VIEWPORTMINX;
unsigned	int ViewPortMinY = VIEWPORTMINY;
unsigned	int	MinBright = MIN_BRIGHT;
unsigned	int	MaxBright = MAX_BRIGHT;
unsigned	int	NormBright = NORM_BRIGHT;
unsigned	int MinStarBright = MINSTARBRIGHT;
unsigned	int MaxStarBright = MAXSTARBRIGHT;
int				starLeftOld;
int				starTopOld;
int				starRightOld;
int				starBottomOld;
int				starLeftNew;
int				starTopNew;
int				starRightNew;
int				starBottomNew;
unsigned	int	SunVisible = SUNVISIBLE;
unsigned	int	SunPresent = SUNPRESENT;
int				SunXPos = SUNXPOS;
int				SunYPos = SUNYPOS;
float			SunGravity = SUNGRAVITY;
float			SunSpin = SUNSPIN;
int				shipPlayer1StartFromMargin = SHIPPLAYER1STARTFROMMARGIN;
int				shipPlayer2StartFromMargin = SHIPPLAYER2STARTFROMMARGIN;
unsigned int	ShipPlayer1StartRot = SHIPPLAYER1STARTROT;
unsigned int	ShipPlayer2StartRot = SHIPPLAYER2STARTROT;
unsigned int	asteroidStartRot = ASTEROIDSTARTROT;
unsigned int	ShipPlayer1Brightness = SHIPPLAYER1BRIGHTNESS;
unsigned int	ShipPlayer2Brightness = SHIPPLAYER2BRIGHTNESS;
unsigned int	FlamePlayer1Brightness = FLAMEPLAYER1BRIGHTNESS;
unsigned int	FlamePlayer2Brightness = FLAMEPLAYER2BRIGHTNESS;
float			asteroidRotSpeed = ASTEROIDROTSPEED;
float			shipPlayer1HyperTime = SHIPPLAYER1HYPERTIME;
float			shipPlayer2HyperTime = SHIPPLAYER2HYPERTIME;
float			shipPlayer1HyperTimer;
float			shipPlayer2HyperTimer;
unsigned	int	starTwinkleNum;
float			ScreenXScaler = 1;
float			ScreenYScaler = 1;
DWORD			dwStyle;
int				appInited = FALSE;
unsigned long	frameCounter;
int				frameTime;
unsigned long	fps;
float			deltaTime;
DWORD			prevTime;
unsigned int	ExplodeInitialBrightness = EXPLODEINITIALBRIGHTNESS;
unsigned int	ExplodeSecondaryBrightness = EXPLODESECONDARYBRIGHTNESS;
float			reentryMaxProb = REENTRYMAXPROB;
float			reentryMinProb = REENTRYMINPROB;
float			reentryProbDecrease = REENTRYPROBDECREASE;
float			player1ReentryCurProb;
float			player2ReentryCurProb;
int				ExplodeLifetime = EXPLODELIFETIME;
float			ExplosionFade = EXPLOSIONFADE;
float			ExplodePausetime = EXPLODEPAUSETIME;
BOOL			soundEnabled = SOUNDENABLED;
BOOL			musicEnabled = MUSICENABLED;
int				ScreenOffLeftMargin = SCREENOFFLEFTMARGIN;
int				ScreenOffTopMargin = SCREENOFFTOPMARGIN;
int				ScreenOffRightMargin = SCREENOFFRIGHTMARGIN;
int				ScreenOffBottomMargin = SCREENOFFBOTTOMMARGIN;
int				ScreenInLeftMargin = SCREENINLEFTMARGIN;
int				ScreenInTopMargin = SCREENINTOPMARGIN;
int				ScreenInRightMargin = SCREENINRIGHTMARGIN;
int				ScreenInBottomMargin = SCREENINBOTTOMMARGIN;
int				MissileBrightness = MISSILEBRIGHTNESS;
int				player1SimulMissiles = PLAYER1SIMULMISSILES;
int				player2SimulMissiles = PLAYER2SIMULMISSILES;
BOOL			Momentum = MOMENTUM;
BOOL			Drag = DRAG;
BOOL			Pause = FALSE;
float			debrisSpinRange = DEBRISSPINRANGE;
float			debrisDirectionVar = DEBRISDIRECTIONVAR;
float			debrisMaxSpeed = DEBRISMAXSPEED;
unsigned int	asteroidFrequency = ASTEROIDFREQUENCY;
int				asteroidBrightness = ASTEROIDBRIGHTNESS;
float			asteroidSpeed = ASTEROIDSPEED;
float			asteroidTimer=(asteroidFrequency/2);
BOOL			missileSpeedAdditive = TRUE;
unsigned int	player1MissileCount;
unsigned int	player2MissileCount;
float			shipPlayer1Mass = SHIPPLAYER1MASS;
float			shipPlayer2Mass = SHIPPLAYER2MASS;
float			asteroidMass = ASTEROIDMASS;
float			missileMass = MISSILEMASS;
float			debrisMass = DEBRISMASS;
UINT			roundInitialTime = ROUNDINITIALTIME;
UINT			player1Frags;
UINT			player2Frags;
float			player1Fuel;
float			player2Fuel;
UINT			player1NumMissiles;
UINT			player2NumMissiles;
int				roundTime;
int				roundTimePrev=0;
float			player1FuelConsumption = PLAYER1FUELCONSUMPTION;
float			player2FuelConsumption = PLAYER2FUELCONSUMPTION;
BOOL			showScores = TRUE;
BOOL			debug = FALSE;
float			damageFlashTime = DAMAGEFLASHTIME;
int				damageFlashBrightness = DAMAGEFLASHBRIGHTNESS;
BOOL			gameOver;
float			sunDistClamp=SUNDISTCLAMP;
float			fragTime=FRAGTIME;
float			fragTimer;
float			attractTime=ATTRACTTIME;
float			attractTimer;
float			attractModeGravTime=ATTRACTMODEGRACTIME;
float			attractModeGravTimer;
UINT			edgeMode = EDGEMODE;
BOOL			attractModeGravInv=FALSE;
BOOL			inverseGravity=INVERSEGRAVITY;
UINT			sunMinBright=SUNMINBRIGHT;
UINT			sunMaxBright=SUNMAXBRIGHT;
float			sunBrightIndex=sunMinBright;
BOOL			sunBrightDir=1;
float			sunAnimateRate=SUNANIMATERATE;
BOOL			enableGravity = TRUE;
float			shipRotSpeed = SHIPROTSPEED;
float			shipMaxSpeed = SHIPMAXSPEED;
float			shipAccel = SHIPACCEL;
float			shipDecel = SHIPDECEL;
UINT			initialFuelAmt = INITIALFUELAMOUNT;
UINT			initialNumMissiles = INITIALNUMMISSILES;
float			missileLifetime = MISSILELIFETIME;
float			missileSpeed = MISSILESPEED;
INTPOINT		offStar, offStarOld;
int				offStarNum=0;
// ------- end of user vars ---------

char			szMessage[255];

FLOATPOINT starCoords[] = {
	512, 279,
	176, 143,
	375, 260,
	131, 346,
	494, 160,
	293, 407,
	330, 109,
	403, 390,
	202, 207,
	412, 330,
	512, 381,
	216, 315,
	480, 264,
	196, 178,
	430, 321,
	339, 222,
	556, 283,
	250, 290,
	181, 272,
	575, 256,
	92, 196,
	439, 225,
	207, 246,
	448, 312,
	0, 0
};


char			keyPlayer1Left=FALSE;
char			keyPlayer1Right=FALSE;
char			keyPlayer1Thrust=FALSE;
char			keyPlayer1Fire=FALSE;
char			keyPlayer1Hyper=FALSE;

char			keyPlayer2Left=FALSE;
char			keyPlayer2Right=FALSE;
char			keyPlayer2Thrust=FALSE;
char			keyPlayer2Fire=FALSE;
char			keyPlayer2Hyper=FALSE;

char			keyStartGame=FALSE;

char			keyDefPlayer1Left = KEYDEFPLAYER1LEFT;
char			keyDefPlayer1Right = KEYDEFPLAYER1RIGHT;
char			keyDefPlayer1Fire = KEYDEFPLAYER1FIRE;
char			keyDefPlayer1Thrust = KEYDEFPLAYER1THRUST;
char			keyDefPlayer1Hyper = KEYDEFPLAYER1HYPER;

char			keyDefPlayer2Left = KEYDEFPLAYER2LEFT;
char			keyDefPlayer2Right = KEYDEFPLAYER2RIGHT;
char			keyDefPlayer2Fire = KEYDEFPLAYER2FIRE;
char			keyDefPlayer2Thrust = KEYDEFPLAYER2THRUST;
char			keyDefPlayer2Hyper = KEYDEFPLAYER2HYPER;

char			keyDefResetGame = KEYDEFRESETGAME;
char			keyDefMinimize = KEYDEFMINIMIZE;
char			keyDefPause = KEYDEFPAUSE;

char			keyDefStartGame=KEYDEFSTARTGAME;

HBITMAP			hBmpOffscreenBuffer=NULL;
HBITMAP			hBmpBkGndBuffer=NULL;

Object2d		*objectList[NUM_OBJECTS+1];

           
// prototypes
//BOOL CALLBACK DlgConsoleProc (HWND HDlg, UINT Msg, UINT WParam, LONG LParam);
BOOL CALLBACK SettingsDlgProc (HWND HDlg, UINT Msg, UINT WParam, LONG LParam);
BOOL CALLBACK KeysDlgProc (HWND HDlg, UINT Msg, UINT WParam, LONG LParam);
BOOL CALLBACK DialogProc (HWND HDlg, UINT Msg,
   UINT WParam, LONG LParam);
BOOL InitInstance (HINSTANCE HInstCurrent, int CmdShow);
void InitProgram (HINSTANCE HInstCurrent);
LRESULT CALLBACK MainWndProc (HWND HWnd, UINT Msg, 
   WPARAM WParam, LPARAM LParam);

void OnDraw(HWND hWnd, HDC DC);
void InitStarField(HWND hWnd);
void DrawStarField(HWND hWnd, HDC DC);
void DrawStars(HWND hWnd, HDC DC);
int  InitGame(HWND hWnd);
void OnDestroy(HWND hWnd);
void SetWindowSize(HWND hWnd);
void CenterWindow(HWND hWnd);
void InitObjects(HWND hWnd);
void OnGameStart(HWND hWnd);
void OnGameEnd(HWND hWnd);
void OnRoundStart(HWND hWnd);
void OnRoundEnd(HWND hWnd);
void UpdateGame(HWND hWnd);
int  CreateOffscreenBuffers(HWND hWnd, HDC DC);
void ExplodeObject(HWND hWnd, Object2d *objP);
void calcSunGravity(Object2d *);
void CreateAsteroid(Object2d *ObjP);
void CollisionCheck(HWND hWnd);
void InitDamage(Object2d *objP);
void InitFatal(Object2d *objP);


/*
 ** WinMain()
 *
 *  FILENAME: d:\progra~1\win32\spacewar\spacewar.cpp
 *
 *  PARAMETERS:
 *
 *  DESCRIPTION:
 *
 *  RETURNS:
 *
 */
int PASCAL WinMain (HINSTANCE HInstCurrent,
   HINSTANCE HInstPrevious, LPSTR CmdLine, int CmdShow){
MSG Msg;
   
	if (!HInstPrevious)            
	// no previous program instance; therefore call InitProgram
	// to register window class:
	InitProgram (HInstCurrent);
                                  
	// call InitInstance to initialize current instance (i.e.
	// create main window):                                  
	if (!InitInstance (HInstCurrent, CmdShow))
		return 0;  // return 0 on error

	// message loop:                          
	while (GetMessage (&Msg, NULL, NULL, NULL)){

		TranslateMessage (&Msg);
		DispatchMessage(&Msg);

	}

	
	return Msg.wParam;  // return "application-defined exit code"
}


/*
 ** DialogProc()
 *
 *  FILENAME: d:\progra~1\win32\spacewar\spacewar.cpp
 *
 *  PARAMETERS:
 *
 *  DESCRIPTION:
 *
 *  RETURNS:
 *
 */
BOOL CALLBACK DialogProc (HWND HDlg, UINT Msg, UINT WParam, LONG LParam){     
	switch (Msg){                                   
		case WM_INITDIALOG:
			// dialog box was just created; return TRUE to have
			// Windows set focus to first control:
			SetWindowText(GetDlgItem(HDlg, IDC_EDIT_CONTACT), szContactInfo);
			return TRUE;
       
		case WM_COMMAND:  // user issued a command
			switch (WParam){           
				case IDCANCEL:
					// user chose Close command on system menu or 
					// pressed Esc; therefore, close the dialog box:
					EndDialog (HDlg, IDCANCEL);
					return TRUE;

				case IDOK:
					// user clicked OK button or pressed Enter;
					// therefore, close the dialog box:               
					EndDialog (HDlg, IDOK);
					return TRUE;

					default:          // have Windows perform default
					return FALSE;  // message processing  
			}

		default:          // have Windows perform default
			return FALSE;  // processing for all other messages
	}
}


/*
 ** InitInstance()
 *
 *  FILENAME: d:\progra~1\win32\spacewar\spacewar.cpp
 *
 *  PARAMETERS:
 *
 *  DESCRIPTION:
 *
 *  RETURNS:
 *
 */
BOOL InitInstance (HINSTANCE HInstCurrent, int CmdShow)
   {
   HWND HWindow; 
                         
   // save handle to current program instance:                         
   HInstance = HInstCurrent;

   // create main window:      
   HWindow = CreateWindow
      ("SpaceWarClass",
      szAppCaption,
      (dwStyle = WS_OVERLAPPED | WS_SYSMENU | WS_MINIMIZEBOX | WS_MAXIMIZEBOX | WS_SIZEBOX),
      CW_USEDEFAULT,
      CW_USEDEFAULT,
      ViewPort_Width,
      ViewPort_Height,
      NULL,
      NULL,
      HInstCurrent,
      NULL);
   if (!HWindow)
      return FALSE;

   // set window to specified state (e.g., normal or minimized):      
   ShowWindow
      (HWindow,
      SW_SHOWMAXIMIZED);

   return TRUE;
   }


/*
 ** InitProgram()
 *
 *  FILENAME: d:\progra~1\win32\spacewar\spacewar.cpp
 *
 *  PARAMETERS:
 *
 *  DESCRIPTION:
 *
 *  RETURNS:
 *
 */
void InitProgram (HINSTANCE HInstCurrent){
WNDCLASS WC;

	WC.style = CS_HREDRAW | CS_VREDRAW | CS_BYTEALIGNCLIENT;
	WC.lpfnWndProc = MainWndProc;
	WC.cbClsExtra = 0;
	WC.cbWndExtra = 0;
	WC.hInstance = HInstCurrent;
	WC.hIcon = LoadIcon (HInstCurrent, "AppIcon");
	WC.hCursor = LoadCursor (NULL, IDC_ARROW);
	WC.hbrBackground = (HBRUSH)GetStockObject (BLACK_BRUSH);                            
	WC.lpszMenuName = "AppMenu";
	WC.lpszClassName = "SpaceWarClass";

	RegisterClass (&WC);

}


/*
 ** MainWndProc()
 *
 *  FILENAME: d:\progra~1\win32\spacewar\spacewar.cpp
 *
 *  PARAMETERS:
 *
 *  DESCRIPTION:
 *
 *  RETURNS:
 *
 */
LRESULT CALLBACK MainWndProc (HWND hWnd, UINT Msg, WPARAM WParam, LPARAM LParam){
HDC DC;
PAINTSTRUCT ps;
RECT rect;
char key;
DWORD	time;

	switch (Msg){
		case WM_COMMAND:  // user chose a command
			switch (WParam){
				case IDM_EXIT:  // user chose Exit menu command;
					DestroyWindow (hWnd);  // destroy main window
					break;

				case IDM_ABOUT:  // user chose About menu command;
					DialogBox       // display the About dialog box
					  (HInstance,  
					  "AboutDlg",
					  hWnd,
					  DialogProc);
					break;
			

				case IDM_SETTINGS:
					KillTimer(hWnd, TIMER1);
					DialogBox       // display the Settings dialog box
					  (HInstance,  
					  "SettingsDlg",
					  hWnd,
					  SettingsDlgProc);
					time = GetCurrentTime();
					deltaTime = 1.0;
					prevTime = time;
					SetTimer (hWnd, TIMER1, 0, NULL);
					break;

				case IDM_CONTROLS:
					DialogBox       // display the About dialog box
					  (HInstance,  
					  "KeysDlg",
					  hWnd,
					  KeysDlgProc);
					break;

				case IDM_STARTGAME:
					if (gameOver){
						OnGameStart(hWnd);
					}
					break;

				case IDM_PAUSEGAME:
					Pause = !Pause;
					break;

				case IDM_MUSIC:
/*					musicEnabled = !musicEnabled;
					HMENU	hMenu;
					hMenu = GetMenu(hWnd);
					if (musicEnabled){
						if (!gameOver){
							playWAV(HInstance, hWnd, "IDR_WAVE_BKGND", TRUE);	
						}
						CheckMenuItem(hMenu, IDM_MUSIC, MF_BYCOMMAND | MF_CHECKED);
					} else {
						stopWAV();
						CheckMenuItem(hMenu, IDM_MUSIC, MF_BYCOMMAND | MF_UNCHECKED);
					}
*/
					break;
				
				case IDM_RESETGAME:
					if (!gameOver){
						OnRoundStart(hWnd);
					}
					break;

				default:     
					// have Windows perform default processing for
					// all other WM_COMMAND messages:
					return DefWindowProc (hWnd, Msg, WParam, LParam);                
			}

		case WM_CREATE:
/*			HMENU	hMenu;
			hMenu = GetMenu(hWnd);
			if (musicEnabled){
				CheckMenuItem(hMenu, IDM_MUSIC, MF_BYCOMMAND | MF_CHECKED);
			} else {
				CheckMenuItem(hMenu, IDM_MUSIC, MF_BYCOMMAND | MF_UNCHECKED);
			}
*/
			return (InitGame(hWnd));
 

		case WM_DESTROY:			// main window is being destroyed
			PostQuitMessage (0);	// post a WM_QUIT message to
			OnDestroy(hWnd);
			break;		          	// cause message loop to exit

		case WM_TIMER :
			// calculate time delta...
			time = GetCurrentTime();
			deltaTime = ((time - prevTime) / (float)CLOCK_TICK);
			prevTime = time;

			if (Pause){ 
				break;  // game is paused...
			}

			DC = GetDC(hWnd);
			UpdateGame(hWnd);
			CollisionCheck(hWnd);
			OnDraw(hWnd, DC);
			ReleaseDC(hWnd, DC);
	
			break;

		case WM_KILLFOCUS :
			break;

		case WM_SETFOCUS :
			break;

		case WM_GETMINMAXINFO:
			MINMAXINFO FAR* 	lpmmi;
		    lpmmi = (MINMAXINFO FAR*) LParam;
		    lpmmi->ptMinTrackSize.x = ViewPortMinX;
		    lpmmi->ptMinTrackSize.y = ViewPortMinY;
		    break;

		case WM_PAINT:
			DC = BeginPaint (hWnd, &ps);
			EndPaint (hWnd, &ps);

			if (hBmpOffscreenBuffer){
				// dump the offscreen buffer to the screen...
				DC = GetDC(hWnd);
				HDC hMemDCOffScreen;    
				hMemDCOffScreen = CreateCompatibleDC(DC);
				OnDraw(hWnd, DC);	// update the screen...
				SelectObject(hMemDCOffScreen, hBmpOffscreenBuffer);
				BitBlt
					(DC,
					0,
					0,
					ViewPort_Width,
					ViewPort_Height,
					hMemDCOffScreen,
					0,
					0,
					SRCCOPY);
				DeleteDC(hMemDCOffScreen);
				ReleaseDC(hWnd, DC);
			}
			break;   

		case WM_SIZE:

			// calculate viewport size...
			GetClientRect(hWnd, &rect);
			ViewPort_Width = (rect.right) - (rect.left);
			ViewPort_Height = (rect.bottom) - (rect.top);

			// calculate screen scaling...
			ScreenXScaler = (float)ViewPort_Width / (float)VIEWPORT_WIDTH;
			ScreenYScaler = (float)ViewPort_Height / (float)VIEWPORT_HEIGHT;

			// adjust/create offscreen buffer area...
			DC = GetDC(hWnd);
			CreateOffscreenBuffers(hWnd, DC);
			ReleaseDC(hWnd, DC);

			break;

		case WM_KEYDOWN:
			key = (int)WParam;

//			sprintf(szMessage, "KEY=%c", key);
//			SetWindowText(hWnd, szMessage);

			if (key == keyDefPlayer1Left){ keyPlayer1Left=TRUE; }
			else if (key == keyDefPlayer1Right){ keyPlayer1Right=TRUE; }
			else if (key == keyDefPlayer1Fire){ keyPlayer1Fire=TRUE; }
			else if (key == keyDefPlayer1Thrust){ keyPlayer1Thrust=TRUE; }
			else if (key == keyDefPlayer1Hyper){ keyPlayer1Hyper=TRUE; }

			else if (key == keyDefPlayer2Left){ keyPlayer2Left=TRUE; }
			else if (key == keyDefPlayer2Right){ keyPlayer2Right=TRUE; }
			else if (key == keyDefPlayer2Fire){ keyPlayer2Fire=TRUE; }
			else if (key == keyDefPlayer2Thrust){ keyPlayer2Thrust=TRUE; }
			else if (key == keyDefPlayer2Hyper){ keyPlayer2Hyper=TRUE; }

			else if (key == keyDefResetGame){ 
				SendMessage(hWnd, WM_COMMAND, IDM_RESETGAME, 0L);
			}
			else if (key == keyDefMinimize){ 
				Pause = TRUE;
				ShowWindow(hWnd, SW_MINIMIZE);
			}
			else if (key == keyDefPause){
				Pause = !Pause;
			}

			else if (key==keyDefStartGame){
				if (!keyStartGame){ // debounce
					keyStartGame = TRUE;
					if (gameOver){
						OnGameStart(hWnd);
					} else {
						if (IDYES == MessageBox(hWnd, "Abort current game?", szAppName, MB_YESNO)){
							OnGameStart(hWnd);
						}
					}
				}
			}
			

			break;

		case WM_KEYUP:
			key = (int)WParam;
			if (key == keyDefPlayer1Left){ keyPlayer1Left=FALSE; }
			else if (key == keyDefPlayer1Right){ keyPlayer1Right=FALSE; }
			else if (key == keyDefPlayer1Fire){ keyPlayer1Fire=FALSE; }
			else if (key == keyDefPlayer1Thrust){ keyPlayer1Thrust=FALSE; }
			else if (key == keyDefPlayer1Hyper){ keyPlayer1Hyper=FALSE; }

			else if (key == keyDefPlayer2Left){ keyPlayer2Left=FALSE; }
			else if (key == keyDefPlayer2Right){ keyPlayer2Right=FALSE; }
			else if (key == keyDefPlayer2Fire){ keyPlayer2Fire=FALSE; }
			else if (key == keyDefPlayer2Thrust){ keyPlayer2Thrust=FALSE; }
			else if (key == keyDefPlayer2Hyper){ keyPlayer2Hyper=FALSE; }

			else if (key == keyDefStartGame){ keyStartGame=FALSE; }
			break;


		default:                                            
			// have Windows perform default processing for all
			// other messages:
			break;
	}


	return DefWindowProc (hWnd, Msg, WParam, LParam);
}



/*
 ** OnDraw()
 *
 *  FILENAME: d:\progra~1\win32\spacewar\spacewar.cpp
 *
 *  PARAMETERS:
 *
 *  DESCRIPTION:
 *
 *  RETURNS:
 *
 */
void OnDraw(HWND hWnd, HDC DC){
HDC		hBuffDC, hBkGndDC;
int		tempTime;
int		numMissile;
int i;
Object2d	*objP;


	// calculate frame rate...
	tempTime = time(NULL);
	if (frameTime != tempTime){
		frameTime = tempTime;
		fps = frameCounter;
		frameCounter = 0;
	} else {
		++frameCounter;
	}

	// get device context to offscreen buffers...
	hBuffDC = CreateCompatibleDC(DC);
	SelectObject(hBuffDC, hBmpOffscreenBuffer);
	hBkGndDC = CreateCompatibleDC(DC);
	SelectObject(hBkGndDC, hBmpBkGndBuffer);


	// erase old player images
	i=0;
	while( objP = objectList[i]){
		if (objP->Visible() || objP->m_eraseMe || objP->Lifetime()){
			BitBlt
				(hBuffDC,
				objP->m_invRect.left,
				objP->m_invRect.top,
				((objP->m_invRect.right) - (objP->m_invRect.left)) + 1,
				((objP->m_invRect.bottom) - (objP->m_invRect.top)) + 1,
				hBkGndDC,
				objP->m_invRect.left,
				objP->m_invRect.top,
				SRCCOPY);
		}
		++i;
	}

	// erase old debris images
	for (i=0; i<MAX_DEBRIS; i++){
		if ((debris[i].Visible()) || (debris[i].m_eraseMe) || (debris[i].Lifetime())){
			BitBlt
				(hBuffDC,
				debris[i].m_invRect.left,
				debris[i].m_invRect.top,
				((debris[i].m_invRect.right) - (debris[i].m_invRect.left)) + 1,
				((debris[i].m_invRect.bottom) - (debris[i].m_invRect.top)) + 1,
				hBkGndDC,
				debris[i].m_invRect.left,
				debris[i].m_invRect.top,
				SRCCOPY);
		}
	}


	// twinkle the stars
	DrawStars(hWnd, hBuffDC);

	if (showScores){
		// erase old score display
		BltScore(hBuffDC, hBkGndDC);

		// draw the new score display
		DrawScore(hBuffDC, digitBrightness);
	}

	// draw the new player images
	i=0;
	while( objP = objectList[i]){
		if (objP->Visible()){
			objP->DrawObject(hBuffDC);
		}
		++i;
	}

	// draw existing debris...
	for (i=0; i<MAX_DEBRIS; i++){
		if (debris[i].Visible()){
			debris[i].DrawObject(hBuffDC);
		}	
	}

	if (showScores){
		// copy the affected score display areas of the offscreen bitmap to the screen...
		BltScore(DC, hBuffDC);
	}

	// copy the affected areas of the offscreen bitmap to the screen...
	i=0;
	while( objP = objectList[i]){
		if (objP->Visible() || objP->m_eraseMe){
			AREARECT UnionRect;
			UnionRect = AreaRectUnion(objP->m_invRect, objP->m_invRectOld);
			UnionRect.right += 1;
			UnionRect.bottom += 1;
			BitBlt
				(DC,
				UnionRect.left,
				UnionRect.top,
				UnionRect.right-UnionRect.left,
				UnionRect.bottom-UnionRect.top,
				hBuffDC,
				UnionRect.left,
				UnionRect.top,
				SRCCOPY);
			if (!(objP->Visible()) && objP->m_eraseMe){
				objP->m_eraseMe = FALSE;
			}

		}
		++i;
	}

	// copy affected debris areas to the screen
	for (i=0; i<MAX_DEBRIS; i++){
		if ((debris[i].Visible()) || (debris[i].m_eraseMe)){
			AREARECT UnionRect;
			UnionRect = AreaRectUnion(debris[i].m_invRect, debris[i].m_invRectOld);
			UnionRect.right += 1;
			UnionRect.bottom += 1;
			BitBlt
				(DC,
				UnionRect.left,
				UnionRect.top,
				UnionRect.right-UnionRect.left,
				UnionRect.bottom-UnionRect.top,
				hBuffDC,
				UnionRect.left,
				UnionRect.top,
				SRCCOPY);
			if (!(debris[i].Visible()) && (debris[i].m_eraseMe)){
				debris[i].m_eraseMe = FALSE;
			}

/*
			// DEBUG - outline the invalidated areas...
			HPEN hPenOld, hPen;
			HBRUSH	hBrushOld;
			hPen = CreatePen(PS_SOLID, 1, RGB(0,0,255));
			hPenOld = (HPEN)SelectObject(DC, hPen);
			hBrushOld = (HBRUSH)SelectObject(DC, GetStockObject(NULL_BRUSH));
			Rectangle(DC, 
				UnionRect.left,
				UnionRect.top,
				UnionRect.right,
				UnionRect.bottom);
			SelectObject(DC, hPenOld);
			SelectObject(DC, hBrushOld);
			DeleteObject(hPen);
*/
		}
	}

	// copy affected twinkling star areas
	BitBlt
		(DC,
		offStar.x*ScreenXScaler,
		offStar.y*ScreenYScaler,
		2,
		2,
		hBuffDC,
		offStar.x*ScreenXScaler,
		offStar.y*ScreenYScaler,
		SRCCOPY);
	BitBlt
		(DC,
		offStarOld.x*ScreenXScaler,
		offStarOld.y*ScreenYScaler,
		2,
		2,
		hBuffDC,
		offStarOld.x*ScreenXScaler,
		offStarOld.y*ScreenYScaler,
		SRCCOPY);


/*	///////////////////////////////////////
			// DEBUG - copy the entire offscreen buffer to screen..
			BitBlt
				(DC,
				0,
				0,
				ViewPort_Width+1,
				ViewPort_Height+1,
				hBuffDC,
				0,
				0,
				SRCCOPY);

*/	///////////////////////////////////////


	// free resources
	DeleteDC(hBuffDC);
	DeleteDC(hBkGndDC);


	if (debug){
		// show debug info...  
		//	SetBkMode(hMemDC, TRANSPARENT);
		SetBkColor(DC, RGB(0,0,0));
		SetTextColor(DC, RGB(255,0,0));
		sprintf(szMessage, "FPS=%d DELTA=%.2f roundTime=%d", fps, deltaTime, roundTime);
		TextOut(DC, 5, 5, szMessage, strlen(szMessage));
	}

}



/*
 ** DrawStarField()
 *
 *  FILENAME: d:\progra~1\win32\spacewar\spacewar.cpp
 *
 *  PARAMETERS:
 *
 *  DESCRIPTION:
 *
 *  RETURNS:
 *
 */
void DrawStarField(HWND hWnd, HDC DC){
int		i;
HPEN	hPen, hPenOld;
int		x, y;


   // select a pen...
	hPen = CreatePen(PS_SOLID, 0, RGB(MaxStarBright, MaxStarBright, MaxStarBright));
	hPenOld = (HPEN)SelectObject(DC, hPen);

	i=0;
	while(starCoords[i].x && starCoords[i].y){
		// draw the stars
		x = (starCoords[i].x)*ScreenXScaler;
		y = (starCoords[i].y)*ScreenYScaler;
		MoveToEx(DC, x, y, NULL);
		LineTo(DC, x+1, y+1);

		i++;
	}

	// remove pen...
	SelectObject(DC, hPenOld);
	DeleteObject(hPen);

}



/*
 ** DrawStars()
 *
 *  FILENAME: d:\progra~1\win32\spacewar\spacewar.cpp
 *
 *  PARAMETERS:
 *
 *  DESCRIPTION:
 *
 *  RETURNS:
 *
 */
void DrawStars(HWND hWnd, HDC DC){
HPEN	hPen, hPenOld;
int		x, y;


	// select the off pen...
	hPen = CreatePen(PS_SOLID, 0, RGB(MinStarBright, MinStarBright, MinStarBright));
	hPenOld = (HPEN)SelectObject(DC, hPen);

	// draw the off star
	x = offStar.x*ScreenXScaler;
	y = offStar.y*ScreenYScaler;
	MoveToEx(DC, x, y, NULL);
	LineTo(DC, x+1, y+1);

	// select the on pen...
	SelectObject(DC, hPenOld);
	DeleteObject(hPen);
	hPen = CreatePen(PS_SOLID, 0, RGB(MaxStarBright, MaxStarBright, MaxStarBright));
	hPenOld = (HPEN)SelectObject(DC, hPen);

	// draw the on star
	x = offStarOld.x*ScreenXScaler;
	y = offStarOld.y*ScreenYScaler;
	MoveToEx(DC, x, y, NULL);
	LineTo(DC, x+1, y+1);

	// remove pen...
	SelectObject(DC, hPenOld);
	DeleteObject(hPen);

}




/*
 ** InitGame()
 *
 *  FILENAME: d:\progra~1\win32\spacewar\spacewar.cpp
 *
 *  PARAMETERS:
 *
 *  DESCRIPTION:
 *
 *  RETURNS:
 *
 */
int InitGame(HWND hWnd){
int i,j;
DWORD	time;

	if (appInited){ return 0; }
	
	appInited = TRUE;

	// generate sine/cosine tables
	make_sin_cos_tables();

	// init the random number generator
	randomize();

	// init delta timer
	prevTime = GetCurrentTime();

	// load the object list
	i=0;
	objectList[i++] = &shipPlayer1Front;
	objectList[i++] = &shipPlayer1Right;
	objectList[i++] = &shipPlayer1Left;
	objectList[i++] = &shipPlayer2Front;
	objectList[i++] = &shipPlayer2Right;
	objectList[i++] = &shipPlayer2Left;
	objectList[i++] = &flamePlayer1;
	objectList[i++] = &flamePlayer2;
	objectList[i++] = &asteroid;
	objectList[i++] = &sunA;
	objectList[i++] = &sunB;
	for (j=0; j<MAX_MISSILES; i++, j++){
		objectList[i] = &player1Missiles[j];
	}
	for (j=0; j<MAX_MISSILES; i++, j++){
		objectList[i] = &player2Missiles[j];
	}
	objectList[i++] = &gameoverObj;
	objectList[i] = NULL;

	// init the game objects
	shipPlayer1.front = &shipPlayer1Front;
	shipPlayer1.right = &shipPlayer1Right;
	shipPlayer1.left = &shipPlayer1Left;

	shipPlayer2.front = &shipPlayer2Front;
	shipPlayer2.right = &shipPlayer2Right;
	shipPlayer2.left = &shipPlayer2Left;

	InitObjects(hWnd);

	// frags, round time...
	OnGameEnd(hWnd);

	// enter attract mode
	gameoverObj.Visible(TRUE);
	attractTimer = 5;

	// start the timer
	time = GetCurrentTime();
	deltaTime = 1.0;
	prevTime = time;
	SetTimer (hWnd, TIMER1, 0, NULL);

	offStar = offStarOld = MakeIntPoint(0,0);
	offStarNum = 0;
	
	return 0;
}


/*
 ** OnDestroy()
 *
 *  FILENAME: d:\progra~1\win32\spacewar\spacewar.cpp
 *
 *  PARAMETERS:
 *
 *  DESCRIPTION:
 *
 *  RETURNS:
 *
 */
void OnDestroy(HWND hWnd){

	// stop the game timer
	KillTimer (hWnd, TIMER1);

	// remove the offscreen buffers
	if (hBmpOffscreenBuffer){
		DeleteObject(hBmpOffscreenBuffer);
	}
	if (hBmpBkGndBuffer){
		DeleteObject(hBmpBkGndBuffer);
	}


}



/*
 ** CenterWindow()
 *
 *  FILENAME: d:\progra~1\win32\spacewar\spacewar.cpp
 *
 *  PARAMETERS:
 *
 *  DESCRIPTION:
 *
 *  RETURNS:
 *
 */
void CenterWindow(HWND hWnd){
RECT rect;
unsigned int x,y;

	GetWindowRect(hWnd, &rect);
	x = (GetSystemMetrics(SM_CXSCREEN) - (rect.right - rect.left)) / 2;
	y = (GetSystemMetrics(SM_CYSCREEN) - (rect.bottom - rect.top)) / 2;
	SetWindowPos(hWnd, NULL, x, y, rect.right - rect.left, rect.bottom - rect.top,
        		SWP_NOSIZE);
}


/*
 ** InitObjects()
 *
 *  FILENAME: d:\progra~1\win32\spacewar\spacewar.cpp
 *
 *  PARAMETERS:
 *
 *  DESCRIPTION:
 *
 *  RETURNS:
 *
 */
void InitObjects(HWND hWnd){
HDC	DC;
int i;
FLOATPOINT pos;


	// load object data...
	shipPlayer1Front.Init(OBJID_PLAYER1FRONT, shipPlayer1NumVerts, shipPlayer1Verts, shipPlayer1FrontNumLines, shipPlayer1FrontLines);
	shipPlayer1Right.Init(OBJID_PLAYER1RIGHT, shipPlayer1NumVerts, shipPlayer1Verts, shipPlayer1RightNumLines, shipPlayer1RightLines);
	shipPlayer1Left.Init(OBJID_PLAYER1LEFT, shipPlayer1NumVerts, shipPlayer1Verts, shipPlayer1LeftNumLines, shipPlayer1LeftLines);

	shipPlayer2Front.Init(OBJID_PLAYER2FRONT, shipPlayer2NumVerts, shipPlayer2Verts, shipPlayer2FrontNumLines, shipPlayer2FrontLines);
	shipPlayer2Right.Init(OBJID_PLAYER2RIGHT, shipPlayer2NumVerts, shipPlayer2Verts, shipPlayer2RightNumLines, shipPlayer2RightLines);
	shipPlayer2Left.Init(OBJID_PLAYER2LEFT, shipPlayer2NumVerts, shipPlayer2Verts, shipPlayer2LeftNumLines, shipPlayer2LeftLines);

	if (asteroidTimer){
		asteroid.Init(OBJID_ASTEROID, asteroidNumVerts, asteroidVerts, asteroidNumLines, asteroidLines);
	}
	flamePlayer1.Init(OBJID_FLAME, flamePlayer1NumVerts, flamePlayer1Verts, flamePlayer1NumLines, flamePlayer1Lines);
	flamePlayer2.Init(OBJID_FLAME, flamePlayer2NumVerts, flamePlayer2Verts, flamePlayer2NumLines, flamePlayer2Lines);
	sunA.Init(OBJID_SUNA, sunNumVerts, sunVerts, sunANumLines, sunALines);
	sunB.Init(OBJID_SUNB, sunNumVerts, sunVerts, sunBNumLines, sunBLines);
	for (i=0; i<(MAX_MISSILES); i++){
		player1Missiles[i].Init(OBJID_MISSILE, missileNumVerts, missileVerts, missileNumLines, missileLines);
		player2Missiles[i].Init(OBJID_MISSILE, missileNumVerts, missileVerts, missileNumLines, missileLines);
	}
	for (i=0; i<(MAX_DEBRIS); i++){
		debris[i].Init(OBJID_DEBRIS, 0, NULL, 0, NULL);
		debris[i].Visible(FALSE);
		debris[i].Lifetime(0.0);
		debris[i].State(OBJSTATE_NORMAL);
		debris[i].Position(MakeFloatPoint(0.0,0.0));
		debris[i].Speed(MakeFloatPoint(0.0,0.0));
		debris[i].Scale(1.0);
	}
	gameoverObj.Init(OBJID_TEXT, gameoverNumVerts, gameoverVerts, gameoverNumLines, gameoverLines);


	// player1 ship...
	shipPlayer1.shipPosition(MakeFloatPoint((ViewPort_Width*(shipPlayer1StartFromMargin/(float)100)/ScreenXScaler), 
		((random() * (ViewPort_Height/2)) + ViewPort_Height/4)/ScreenYScaler));
	shipPlayer1.shipRotate(ShipPlayer1StartRot);
	shipPlayer1.shipSpeed(MakeFloatPoint(0.0, 0.0));
	shipPlayer1.shipVisible(TRUE);
	shipPlayer1.shipState(OBJSTATE_NORMAL);
	shipPlayer1.shipSpin(0.0);
	shipPlayer1.shipBrightness(ShipPlayer1Brightness);
	shipPlayer1.shipScale(shipPlayer1Scale);
	shipPlayer1.shipLifetime(0.0);
	pos = shipPlayer1.front->Position();
	shipPlayer1.front->m_invRect = shipPlayer1.front->m_invRectOld = 
		MakeAreaRect(pos.x, pos.y, pos.x, pos.y);
	shipPlayer1.right->m_invRect = shipPlayer1.right->m_invRectOld = 
		MakeAreaRect(pos.x, pos.y, pos.x, pos.y);
	shipPlayer1.left->m_invRect = shipPlayer1.left->m_invRectOld = 
		MakeAreaRect(pos.x, pos.y, pos.x, pos.y);


	// player2 ship...
	shipPlayer2.shipPosition(MakeFloatPoint(((ViewPort_Width - (ViewPort_Width*(shipPlayer2StartFromMargin/(float)100)))/ScreenXScaler), 
		((random() * (ViewPort_Height/2)) + ViewPort_Height/4)/ScreenYScaler));
	shipPlayer2.shipRotate(ShipPlayer2StartRot);
	shipPlayer2.shipSpeed(MakeFloatPoint(0.0, 0.0));
	shipPlayer2.shipVisible(TRUE);
	shipPlayer2.shipState(OBJSTATE_NORMAL);
	shipPlayer2.shipSpin(0.0);
	shipPlayer2.shipBrightness(ShipPlayer2Brightness);
	shipPlayer2.shipScale(shipPlayer2Scale);
	shipPlayer2.shipLifetime(0.0);
	pos = shipPlayer2.front->Position();
	shipPlayer2.front->m_invRect = shipPlayer2.front->m_invRectOld = 
		MakeAreaRect(pos.x, pos.y, pos.x, pos.y);
	shipPlayer2.right->m_invRect = shipPlayer2.right->m_invRectOld = 
		MakeAreaRect(pos.x, pos.y, pos.x, pos.y);
	shipPlayer2.left->m_invRect = shipPlayer2.left->m_invRectOld = 
		MakeAreaRect(pos.x, pos.y, pos.x, pos.y);


	// player1 flame
	flamePlayer1.Position(shipPlayer1.shipPosition());
	flamePlayer1.Rotate(shipPlayer1.shipRotate());
	flamePlayer1.Speed(MakeFloatPoint(0.0, 0.0));
	flamePlayer1.Visible(FALSE);
	flamePlayer1.State(OBJSTATE_NORMAL);
	flamePlayer1.Spin(0.0);
	flamePlayer1.Brightness(FlamePlayer1Brightness);
	flamePlayer1.Scale(flamePlayer1Scale);


	// player2 flame
	flamePlayer2.Position(shipPlayer2.shipPosition());
	flamePlayer2.Rotate(shipPlayer2.shipRotate());
	flamePlayer2.Speed(MakeFloatPoint(0.0, 0.0));
	flamePlayer2.Visible(FALSE);
	flamePlayer2.State(OBJSTATE_NORMAL);
	flamePlayer2.Spin(0.0);
	flamePlayer2.Brightness(FlamePlayer2Brightness);
	flamePlayer2.Scale(flamePlayer2Scale);


	// asteroid (only init if not currently on screen...)
	if (asteroidTimer){
		asteroid.Position(MakeFloatPoint(0.0, 0.0));
		asteroid.Rotate(asteroidStartRot);
		asteroid.Speed(MakeFloatPoint(0.0, 0.0));
		asteroid.Visible(FALSE);
		asteroid.State(OBJSTATE_NORMAL);
		asteroid.Spin(0.0);
		asteroid.Brightness(asteroidBrightness);
		asteroid.Scale(asteroidScale);
		asteroidTimer = (asteroidFrequency/2);
	}

	// the sun
	sunA.Position(MakeFloatPoint(SunXPos, SunYPos));
	sunA.Rotate(0);
	sunA.Speed(MakeFloatPoint(0.0, 0.0));
	sunA.Visible(SunVisible && SunPresent);
	sunA.State(OBJSTATE_NORMAL);
	sunA.Spin(SunSpin);
	sunA.Brightness(sunBrightIndex);
	sunA.Scale(sunScale);
	sunA.Lifetime(0.0);
	sunB.Position(MakeFloatPoint(SunXPos, SunYPos));
	sunB.Rotate(0);
	sunB.Speed(MakeFloatPoint(0.0, 0.0));
	sunB.Visible(SunVisible && SunPresent);
	sunB.State(OBJSTATE_NORMAL);
	sunB.Spin(SunSpin);
	sunB.Brightness(sunMaxBright-sunBrightIndex);
	sunB.Scale(sunScale);
	sunB.Lifetime(0.0);

	// missiles
	for (i=0; i<(MAX_MISSILES); i++){
		player1Missiles[i].Position(MakeFloatPoint(0.0, 0.0));
		player1Missiles[i].Rotate(0.0);
		player1Missiles[i].Speed(MakeFloatPoint(0.0, 0.0));
		player1Missiles[i].Visible(FALSE);
		player1Missiles[i].State(OBJSTATE_NORMAL);
		player1Missiles[i].Spin(0.0);
		player1Missiles[i].Brightness(MissileBrightness);
		player1Missiles[i].Scale(missileScale);
		player1Missiles[i].Lifetime(0.0);

		player2Missiles[i].Position(MakeFloatPoint(0.0, 0.0));
		player2Missiles[i].Rotate(0);
		player2Missiles[i].Speed(MakeFloatPoint(0.0, 0.0));
		player2Missiles[i].Visible(FALSE);
		player2Missiles[i].State(OBJSTATE_NORMAL);
		player2Missiles[i].Spin(0.0);
		player2Missiles[i].Brightness(MissileBrightness);
		player2Missiles[i].Scale(missileScale);
		player2Missiles[i].Lifetime(0.0);
	}

	// "game over"
	gameoverObj.Position(MakeFloatPoint(SunXPos, SunYPos/2));
	gameoverObj.Rotate(0);
	gameoverObj.Speed(MakeFloatPoint(0.0, 0.0));
	gameoverObj.Visible(FALSE);
	gameoverObj.State(OBJSTATE_NORMAL);
	gameoverObj.Spin(0.0);
	gameoverObj.Brightness(NormBright);
	gameoverObj.Scale(gameoverScale);


}


/*
 ** OnGameStart()
 *
 *  FILENAME: d:\progra~1\win32\spacewar\spacewar.cpp
 *
 *  PARAMETERS:
 *
 *  DESCRIPTION:
 *
 *  RETURNS:
 *
 */
void OnGameStart(HWND hWnd){
Object2d	*objP;

	// start the game...
	gameOver = FALSE;
	roundTime = roundInitialTime;
	roundTimePrev = 0;
	player1Frags = 0;
	player2Frags = 0;
	gameoverObj.Visible(FALSE);

	// start the music
/*	if (musicEnabled){
		playWAV(HInstance, hWnd, "IDR_WAVE_BKGND", TRUE);
	}
*/
	OnRoundStart(hWnd);

}


/*
 ** OnRoundStart()
 *
 *  FILENAME: d:\progra~1\win32\spacewar\spacewar.cpp
 *
 *  PARAMETERS:
 *
 *  DESCRIPTION:
 *
 *  RETURNS:
 *
 */
void OnRoundStart(HWND hWnd){
Object2d	*objP;
UINT		i;
HDC	DC;

	// update the score
	if ((shipPlayer1.shipState() == OBJSTATE_DESTROYED)
		|| (shipPlayer1.shipState() == OBJSTATE_EXPLODING)){
		player2Frags++;
	}
	if ((shipPlayer2.shipState() == OBJSTATE_DESTROYED)
		|| (shipPlayer2.shipState() == OBJSTATE_EXPLODING)){
		player1Frags++;
	}

	// init the game objects
	InitObjects(hWnd);

	// set the edge mode...
	i=0;
	while( objP = objectList[i]){
		objP->EdgeAction(edgeMode);
		i++;
	}

	// init hyperspace stuff
	shipPlayer1HyperTimer = 0;
	shipPlayer2HyperTimer = 0;
	player1ReentryCurProb = reentryMaxProb;
	player2ReentryCurProb = reentryMaxProb;	

	// fuel/missile amounts...
	player1Fuel = initialFuelAmt;
	player2Fuel = initialFuelAmt;
	player1NumMissiles = initialNumMissiles;
	player2NumMissiles = initialNumMissiles;

	// show the frags for a while
	fragTimer = fragTime;

	// repaint screen
	DC = GetDC(hWnd);
	CreateOffscreenBuffers(hWnd, DC);
	ReleaseDC(hWnd, DC);

	RECT rect;
	GetClientRect(hWnd, &rect);
	InvalidateRect(hWnd, &rect, TRUE);

}


/*
 ** UpdateGame()
 *
 *  FILENAME: d:\progra~1\win32\spacewar\spacewar.cpp
 *
 *  PARAMETERS:
 *
 *  DESCRIPTION:
 *
 *  RETURNS:
 *
 */
void UpdateGame(HWND hWnd){
FLOATPOINT speed, point, tempSpeed;
int numMissile, i;
float value;
Object2d *objP;
BOOL hitEdge, debrisPresent;
int tempTime;
BOOL player1CanMove, player2CanMove;
BOOL player1Damaged, player2Damaged;


	// twinkle the stars
	offStarOld = offStar;
	++offStarNum;
	if ((starCoords[offStarNum].x == 0)
		&& (starCoords[offStarNum].y == 0)){
		offStarNum = 0;
	}
	offStar.x = starCoords[offStarNum].x;
	offStar.y = starCoords[offStarNum].y;


	if (!gameOver){

		// disallow movement keys if damaged or exploding....
		if (shipPlayer1.shipState() == OBJSTATE_NORMAL){
			player1Damaged = FALSE;
			player1CanMove = TRUE;
		} else {
			player1Damaged = TRUE;
			if ((shipPlayer1.right->State() == OBJSTATE_NORMAL)
				|| (shipPlayer1.left->State() == OBJSTATE_NORMAL)){
				player1CanMove = TRUE;
			} else {
				player1CanMove = FALSE;
			}
		}	
		if (shipPlayer2.shipState() == OBJSTATE_NORMAL){
			player2Damaged = FALSE;
			player2CanMove = TRUE;
		} else {
			player2Damaged = TRUE;
			if ((shipPlayer2.right->State() == OBJSTATE_NORMAL)
				|| (shipPlayer2.left->State() == OBJSTATE_NORMAL)){
				player2CanMove = TRUE;
			} else {
				player2CanMove = FALSE;
			}
		}	

		
		if (player1CanMove){
			
			/* player 1 keys */
			if (keyPlayer1Left && player1Fuel){
				if (player1Damaged){
					shipPlayer1.shipRotate(shipPlayer1.shipRotate()-((shipRotSpeed/2) * deltaTime));
				} else {
					shipPlayer1.shipRotate(shipPlayer1.shipRotate()-((shipRotSpeed) * deltaTime));
				}
			}
			if (keyPlayer1Right && player1Fuel){
				if (player1Damaged){
					shipPlayer1.shipRotate(shipPlayer1.shipRotate()+((shipRotSpeed/2) * deltaTime));
				} else {
					shipPlayer1.shipRotate(shipPlayer1.shipRotate()+((shipRotSpeed) * deltaTime));
				}
			}
			if (keyPlayer1Thrust && player1Fuel){

				// reduce fuel amount
				player1Fuel -= player1FuelConsumption;
				if (player1Fuel < 0.0){
					player1Fuel = 0.0;
				}

				// show "thrust flame"
				if (flamePlayer1.Visible()){
					flamePlayer1.Visible(FALSE);
				} else {
					flamePlayer1.Visible(TRUE);
				}

				// accelerate the object...
				if (Momentum){
					if (player1Damaged){
						speed=MakeFloatPoint(0.0, ((shipAccel/3) * deltaTime));
					} else {
						speed=MakeFloatPoint(0.0, ((shipAccel) * deltaTime));
					}
				} else {
					if (player1Damaged){
						speed=MakeFloatPoint(0.0, ((shipMaxSpeed/3) * deltaTime));
					} else {
						speed=MakeFloatPoint(0.0, ((shipMaxSpeed) * deltaTime));
					}
					shipPlayer1.shipSpeed(MakeFloatPoint(0.0, 0.0));
				}

				// rotate distance to correct direction
				speed = RotatePoint(speed, shipPlayer1.shipRotate());
				// update object speed
				speed = shipPlayer1.shipSpeed() + speed;

				// range check
				tempSpeed = speed;
				if (tempSpeed.x < 0.0){ tempSpeed.x = -tempSpeed.x; }
				if (tempSpeed.y < 0.0){ tempSpeed.y = -tempSpeed.y; }
				if (((tempSpeed.x) > shipMaxSpeed)
					|| ((tempSpeed.y) > shipMaxSpeed)){
					if (tempSpeed.x > tempSpeed.y){
						tempSpeed.y = (tempSpeed.x * tempSpeed.y)/tempSpeed.x;
						tempSpeed.x = shipMaxSpeed;
					}
					else if (tempSpeed.y > tempSpeed.x){
						tempSpeed.x = (tempSpeed.y * tempSpeed.x)/tempSpeed.y;
						tempSpeed.y = shipMaxSpeed;
					} else {
						tempSpeed.x = shipMaxSpeed;
						tempSpeed.y = shipMaxSpeed;
					}
					if (speed.x < 0.0){ tempSpeed.x = -tempSpeed.x; }
					if (speed.y < 0.0){ tempSpeed.y = -tempSpeed.y; }
					speed = tempSpeed;
				}

				// update ship speed
				shipPlayer1.shipSpeed(speed);

			}
			// update the thrust flame
			flamePlayer1.Position(shipPlayer1.shipPosition());
			flamePlayer1.Rotate(shipPlayer1.shipRotate());
		} else {
			flamePlayer1.Visible(FALSE);
		}

		// player1 hyperspace...
		if ((0==shipPlayer1HyperTimer) 
			&& keyPlayer1Hyper
			&& player1Fuel
			&& (player1CanMove)){
			// send the ship into hyperspace!
			shipPlayer1HyperTimer = shipPlayer1HyperTime;
			shipPlayer1.shipState(OBJSTATE_HYPERSPACE);
			shipPlayer1.shipVisible(FALSE);
		}
		if (shipPlayer1HyperTimer){
			shipPlayer1HyperTimer -= 1 * deltaTime;
			if (shipPlayer1HyperTimer <= 0){
				// bring the ship out of hyperspace...
				// randomly place the ship on the screen
				shipPlayer1HyperTimer = 0.0;
				shipPlayer1.shipSpeed(MakeFloatPoint(0.0, 0.0));
				shipPlayer1.shipPosition(MakeFloatPoint(((random() * (ViewPort_Width/2)) + ViewPort_Width/4)/ScreenXScaler,
					((random() * (ViewPort_Height/2)) + ViewPort_Height/4)/ScreenYScaler));
				shipPlayer1.shipState(OBJSTATE_NORMAL);
				shipPlayer1.shipVisible(TRUE);

				// did we blow up?
				if ((random() * 100) > player1ReentryCurProb){
					// yes! we blew up
					InitFatal(shipPlayer1.front);
					InitFatal(shipPlayer1.right);
					InitFatal(shipPlayer1.left);
				} else {
					// no - we didn't blow up...
					// but increase the chances for next time!
					player1ReentryCurProb -= reentryProbDecrease;
					if (player1ReentryCurProb < reentryMinProb){
						player1ReentryCurProb = reentryMinProb;
					}
				}

			}
		}


		if (player2CanMove){

			/* player 2 keys */
			if (keyPlayer2Left && player2Fuel){
				if (player2Damaged){
					shipPlayer2.shipRotate(shipPlayer2.shipRotate()-((shipRotSpeed/2) * deltaTime));
				} else {
					shipPlayer2.shipRotate(shipPlayer2.shipRotate()-(shipRotSpeed * deltaTime));
				}
			}
			if (keyPlayer2Right && player2Fuel){
				if (player2Damaged){
					shipPlayer2.shipRotate(shipPlayer2.shipRotate()+((shipRotSpeed/2) * deltaTime));
				} else {
					shipPlayer2.shipRotate(shipPlayer2.shipRotate()+(shipRotSpeed * deltaTime));
				}
			}
			if (keyPlayer2Thrust && player2Fuel){
	
				// reduce fuel amount
				player2Fuel -= player2FuelConsumption;
				if (player2Fuel < 0.0){
					player2Fuel = 0.0;
				}

				// show "thrust flame"
				if (flamePlayer2.Visible()){
					flamePlayer2.Visible(FALSE);
				} else {
					flamePlayer2.Visible(TRUE);
				}

				// accelerate the object...
				if (Momentum){
					if (player2Damaged){
						speed=MakeFloatPoint(0.0, ((shipAccel/3) * deltaTime));
					} else {
						speed=MakeFloatPoint(0.0, (shipAccel * deltaTime));
					}
				} else {
					if (player2Damaged){
						speed=MakeFloatPoint(0.0, ((shipMaxSpeed/3) * deltaTime));
					} else {
						speed=MakeFloatPoint(0.0, (shipMaxSpeed * deltaTime));
					}
					shipPlayer2.shipSpeed(MakeFloatPoint(0.0, 0.0));
				}

				// rotate distance to correct direction
				speed = RotatePoint(speed, shipPlayer2.shipRotate());
				// update object speed
				speed = shipPlayer2.shipSpeed() + speed;

				// range check
				tempSpeed = speed;
				if (tempSpeed.x < 0.0){ tempSpeed.x = -tempSpeed.x; }
				if (tempSpeed.y < 0.0){ tempSpeed.y = -tempSpeed.y; }
				if (((tempSpeed.x) > shipMaxSpeed)
					|| ((tempSpeed.y) > shipMaxSpeed)){
					if (tempSpeed.x > tempSpeed.y){
						tempSpeed.y = (tempSpeed.x * tempSpeed.y)/tempSpeed.x;
						tempSpeed.x = shipMaxSpeed;
					}
					else if (tempSpeed.y > tempSpeed.x){
						tempSpeed.x = (tempSpeed.y * tempSpeed.x)/tempSpeed.y;
						tempSpeed.y = shipMaxSpeed;
					} else {
						tempSpeed.x = shipMaxSpeed;
						tempSpeed.y = shipMaxSpeed;
					}
					if (speed.x < 0.0){ tempSpeed.x = -tempSpeed.x; }
					if (speed.y < 0.0){ tempSpeed.y = -tempSpeed.y; }
					speed = tempSpeed;
				}

				// update ship speed
				shipPlayer2.shipSpeed(speed);

			}
			// update the thrust flame
			flamePlayer2.Position(shipPlayer2.shipPosition());
			flamePlayer2.Rotate(shipPlayer2.shipRotate());
		} else {
			flamePlayer2.Visible(FALSE);
		}


		// player2 hyperspace...
		if ((0==shipPlayer2HyperTimer) 
			&& keyPlayer2Hyper
			&& player2Fuel
			&& (player2CanMove)){
			// send the ship into hyperspace!
			shipPlayer2HyperTimer = shipPlayer2HyperTime;
			shipPlayer2.shipState(OBJSTATE_HYPERSPACE);
			shipPlayer2.shipVisible(FALSE);
		}
		if (shipPlayer2HyperTimer){
			shipPlayer2HyperTimer -= 1 * deltaTime;
			if (shipPlayer2HyperTimer <= 0){
				// bring the ship out of hyperspace...
				// randomly place the ship on the screen
				shipPlayer2HyperTimer = 0.0;
				shipPlayer2.shipSpeed(MakeFloatPoint(0.0, 0.0));
				shipPlayer2.shipPosition(MakeFloatPoint(((random() * (ViewPort_Width/2)) + ViewPort_Width/4)/ScreenXScaler,
					((random() * (ViewPort_Height/2)) + ViewPort_Height/4)/ScreenYScaler));
				shipPlayer2.shipState(OBJSTATE_NORMAL);
				shipPlayer2.shipVisible(TRUE);

				// did we blow up?
				if ((random() * 100) > player2ReentryCurProb){
					// yes! we blew up
					InitFatal(shipPlayer2.front);
					InitFatal(shipPlayer2.right);
					InitFatal(shipPlayer2.left);
				} else {
					// no - we didn't blow up...
					// but increase the chances for next time!
					player2ReentryCurProb -= reentryProbDecrease;
					if (player2ReentryCurProb < reentryMinProb){
						player2ReentryCurProb = reentryMinProb;
					}
				}

			}
		}


		// player 1 - fire a missile
		if ((shipPlayer1.shipState() <= OBJSTATE_DAMAGED)
			&& (keyPlayer1Fire)
			&& (player1NumMissiles)){

			// set to false so we don't get multiple missiles...
			keyPlayer1Fire=FALSE;

			// decrement number of missiles
			--player1NumMissiles;

			// find an available missile
			int missileNum, i, found;
			i=0;
			found = FALSE;
			do {
				if (player1Missiles[i].Lifetime() == 0){
					missileNum = i;
					found = TRUE;
				}
				i++;
			} while ((!found) && (i<MAX_MISSILES) && (i<player1SimulMissiles));
			if (found){
				// found a missile, set it in motion...
				player1Missiles[missileNum].Lifetime(missileLifetime);
				player1Missiles[missileNum].Brightness(MissileBrightness);
				player1Missiles[missileNum].Visible(TRUE);
				// rotate distance to correct direction
				speed = RotatePoint((MakeFloatPoint(0.0, missileSpeed)), shipPlayer1.shipRotate());
				if (missileSpeedAdditive){
					// make missile speed additive to player speed;
					speed += shipPlayer1.shipSpeed();		
				}
				// set the missile's speed...
				player1Missiles[missileNum].Speed(speed);
				// starting location is the current screen location of the 
				// player 1 ship's first vertex...
				point = shipPlayer1.front->m_verts[0];
				point.x *= shipPlayer1Scale;
				point.y *= shipPlayer1Scale;
				point.y += 2*shipPlayer1Scale; // don't explode in the barrel!
				// rotate distance to correct angle
				point = RotatePoint(point, shipPlayer1.shipRotate());
				point += shipPlayer1.shipPosition();
				player1Missiles[missileNum].Position(point);

			}
		}
		// player 2 - fire a missile
		if ((shipPlayer2.shipState() <= OBJSTATE_DAMAGED)
			&& (keyPlayer2Fire)
			&& (player2NumMissiles)){

			// set to false so we don't get multiple missiles...
			keyPlayer2Fire=FALSE;

			// decrement number of missiles
			--player2NumMissiles;

			// find an available missile
			int missileNum, i, found;
			i=0;
			found = FALSE;
			do {
				if (player2Missiles[i].Lifetime() == 0){
					missileNum = i;
					found = TRUE;
				}
				i++;
			} while ((!found) && (i<MAX_MISSILES) && (i<player2SimulMissiles));
			if (found){
				// found a missile, set it in motion...
				player2Missiles[missileNum].Lifetime(missileLifetime);
				player2Missiles[missileNum].Brightness(MissileBrightness);
				player2Missiles[missileNum].Visible(TRUE);
				// rotate distance to correct direction
				speed = RotatePoint((MakeFloatPoint(0.0, missileSpeed)), shipPlayer2.shipRotate());
				if (missileSpeedAdditive){
					// make missile speed additive to player speed;
					speed += shipPlayer2.shipSpeed();		
				}
				// set the missile's speed...
				player2Missiles[missileNum].Speed(speed);
				// starting location is the current screen location of the 
				// player 2 ship's first vertex...
				point = shipPlayer2.front->m_verts[0];
				point.x *= shipPlayer2Scale;
				point.y *= shipPlayer2Scale;
				point.y += 2*shipPlayer2Scale; // don't explode in the barrel!
				// rotate distance to correct angle
				point = RotatePoint(point, shipPlayer2.shipRotate());
				point += shipPlayer2.shipPosition();		
				player2Missiles[missileNum].Position(point);

			}
		}

	}

	// player1 thrust is off
	if (!keyPlayer1Thrust || (player1Fuel==0.0)){

		// turn off the flame
		flamePlayer1.Visible(FALSE);

		// decelerate the object...
		if (Drag && !gameOver){
			speed = shipPlayer1.shipSpeed();
			if (speed.x > 0){
				speed.x -= shipDecel * deltaTime;
				if (speed.x < 0){ speed.x = 0; }
			} 
			else if (speed.x < 0){
				speed.x += shipDecel * deltaTime;
				if (speed.x > 0){ speed.x = 0; }
			} 

			if (speed.y > 0){
				speed.y -= shipDecel * deltaTime;
				if (speed.y < 0){ speed.y = 0; }
			} 
			else if (speed.y < 0){
				speed.y += shipDecel * deltaTime;
				if (speed.y > 0){ speed.y = 0; }
			} 
			shipPlayer1.shipSpeed(speed);
		} else {
			if (!Momentum && !gameOver){
				shipPlayer1.shipSpeed(MakeFloatPoint(0.0, 0.0));
			}
		}

	}

	// player2 thrust is off
	if (!keyPlayer2Thrust || (player2Fuel==0.0)){

		// turn off the flame
		flamePlayer2.Visible(FALSE);

		// decelerate the object...
		if (Drag && !gameOver){
			speed = shipPlayer2.shipSpeed();
			if (speed.x > 0){
				speed.x -= shipDecel * deltaTime;
				if (speed.x < 0){ speed.x = 0; }
			} 
			else if (speed.x < 0){
				speed.x += shipDecel * deltaTime;
				if (speed.x > 0){ speed.x = 0; }
			} 

			if (speed.y > 0){
				speed.y -= shipDecel * deltaTime;
				if (speed.y < 0){ speed.y = 0; }
			} 
			else if (speed.y < 0){
				speed.y += shipDecel * deltaTime;
				if (speed.y > 0){ speed.y = 0; }
			} 
			shipPlayer2.shipSpeed(speed);
		} else {
			if (!Momentum && !gameOver){
				shipPlayer2.shipSpeed(MakeFloatPoint(0.0, 0.0));
			}
		}

	}

	
	// go through the object list...
	i=0;
	while(objP=objectList[i]){
		// process gravity
		if (SunPresent){
			if (enableGravity || gameOver){
				if ((objP->ObjectID() != OBJID_SUNA)
					&& (objP->ObjectID() != OBJID_SUNB)){
					calcSunGravity(objP);
				}
			}
		}
		if ((!gameOver || !attractTimer)
			|| (objP->ObjectID()==OBJID_MISSILE)
			|| (objP->ObjectID()==OBJID_ASTEROID)){
			// update positions...
			hitEdge = objP->UpdatePosition(deltaTime);
			if (hitEdge){ objP->m_posOld = objP->m_pos; } // for collision checking...
		}
		// do asteroid creation/removal...
		if (objP->ObjectID() == OBJID_ASTEROID){
			if (asteroidTimer == 0.0){
				if (hitEdge){
					// off the screen...remove the asteroid
					objP->Visible(FALSE);
					asteroidTimer = asteroidFrequency;
				}
			} else {
				asteroidTimer -=  deltaTime;
				if (asteroidTimer <= 0.0){
					// create a new asteroid
					asteroidTimer = 0.0;
					CreateAsteroid(objP);
				}
			}
		}
		// finished with preexplosion pause, now blow up
		if ((objP->State() == OBJSTATE_EXPLODING) 
			&& (objP->Lifetime() == 0)){
			ExplodeObject(hWnd, objP);
		}
		

		++i;
	}

	// realign the ship 'pieces' after applying sun gravity
	shipPlayer1.Align();
	shipPlayer2.Align();

	// update existing debris...
	for (debrisPresent=FALSE, i=0; i<MAX_DEBRIS; i++){
		if (debris[i].Lifetime()){
			debrisPresent = TRUE;
			hitEdge = debris[i].UpdatePosition(deltaTime);
			if (hitEdge){
				debris[i].Visible(FALSE);
				debris[i].Lifetime(0.0);
			}
			if (debris[i].Lifetime() == 0){
				ExplodeObject(hWnd, &debris[i]);
			}
		}
	}


	// update the thrust flames
	if (shipPlayer1.shipState() <= OBJSTATE_DAMAGED){
		flamePlayer1.Position(shipPlayer1.shipPosition());
		flamePlayer1.Rotate(shipPlayer1.shipRotate());
	} else {
		flamePlayer1.Visible(FALSE);
	}
	if (shipPlayer2.shipState() <= OBJSTATE_DAMAGED){
		flamePlayer2.Position(shipPlayer2.shipPosition());
		flamePlayer2.Rotate(shipPlayer2.shipRotate());
	} else {
		flamePlayer2.Visible(FALSE);
	}


	// make fuel and num missiles 0 if destroyed...
	if (shipPlayer1.shipState() == OBJSTATE_DESTROYED){
		player1Fuel = 0.0;
		player1NumMissiles = 0;
	}
	if (shipPlayer2.shipState() == OBJSTATE_DESTROYED){
		player2Fuel = 0.0;
		player2NumMissiles = 0;
	}

	// make fuel 0 if both engines are destroyed...
	if ((shipPlayer1.right->State() == OBJSTATE_DESTROYED)
		&& (shipPlayer1.left->State() == OBJSTATE_DESTROYED)){
		player1Fuel = 0.0;
	}
	if ((shipPlayer2.right->State() == OBJSTATE_DESTROYED)
		&& (shipPlayer2.left->State() == OBJSTATE_DESTROYED)){
		player2Fuel = 0.0;
	}

	// animate the sun
	if (sunBrightDir){
		sunBrightIndex-=sunAnimateRate * deltaTime;
		if (sunBrightIndex <= sunMinBright){
			sunBrightIndex = sunMinBright;
			sunBrightDir = !sunBrightDir;
		}
	} else {
		sunBrightIndex+=sunAnimateRate * deltaTime;
		if (sunBrightIndex >= sunMaxBright){
			sunBrightIndex = sunMaxBright;
			sunBrightDir = !sunBrightDir;
		}
	}
	sunA.Brightness(sunBrightIndex-(sunMinBright/4));
	sunB.Brightness((sunMaxBright-sunBrightIndex)+sunMinBright);

	// update timers
	tempTime = time(NULL);
	if (roundTimePrev != tempTime){
		// check for end of game...
		if (roundTime){
			--roundTime;
			if (roundTime <= 0){
				roundTime = 0;
				// game over, man!
				OnGameEnd(hWnd);
			}
		}
		// show the scores for a while...
		--fragTimer;
		if (fragTimer <= 0){
			fragTimer = 0;
		}
		// attract mode
		if (attractTimer){
			--attractTimer;
			if (attractTimer <= 0){
				if (gameOver){
					// set the edge mode to bounce...
					i=0;
					while( objP = objectList[i]){
						objP->EdgeAction(EDGEACT_BOUNCE);
						i++;
					}
					// enter attract mode...
					attractTimer = 0;
					// randomly place the ships
					shipPlayer1.shipBrightness(ShipPlayer1Brightness);
					shipPlayer2.shipBrightness(ShipPlayer2Brightness);
					shipPlayer1.shipState(OBJSTATE_NORMAL);
					shipPlayer2.shipState(OBJSTATE_NORMAL);
					shipPlayer1.shipVisible(TRUE);
					shipPlayer2.shipVisible(TRUE);
					shipPlayer1.shipSpeed(MakeFloatPoint(0.0, 0.0));
					shipPlayer2.shipSpeed(MakeFloatPoint(0.0, 0.0));
					shipPlayer1.shipRotate((int)((float)random()*NUMBER_OF_DEGREES));
					shipPlayer2.shipRotate((int)((float)random()*NUMBER_OF_DEGREES));
					shipPlayer1.shipPosition(MakeFloatPoint(((random() * (ViewPort_Width/2)) + ViewPort_Width/4)/ScreenXScaler,
						((random() * (ViewPort_Height/2)) + ViewPort_Height/4)/ScreenYScaler));
					shipPlayer2.shipPosition(MakeFloatPoint(((random() * (ViewPort_Width/2)) + ViewPort_Width/4)/ScreenXScaler,
						((random() * (ViewPort_Height/2)) + ViewPort_Height/4)/ScreenYScaler));
					// invert the gravity
					attractModeGravInv=TRUE;
				}
			}
		}
		// flip the gravity around in attract mode
		if (gameOver){
			--attractModeGravTimer;
			if (attractModeGravTimer <= 0){
				attractModeGravTimer = attractModeGravTime;
				// flip the gravity around...
				attractModeGravInv = !attractModeGravInv;
			}
		}
		roundTimePrev = tempTime;
	}	

	// check for end of round...
	if ( (!debrisPresent)
		&& ((shipPlayer1.shipState() == OBJSTATE_DESTROYED)
		|| (shipPlayer2.shipState() == OBJSTATE_DESTROYED)) ){
		if ((shipPlayer1.shipState() != OBJSTATE_EXPLODING)
			&& (shipPlayer2.shipState() != OBJSTATE_EXPLODING)){
			if (!gameOver){
				OnRoundEnd(hWnd);
			}
		}
	}	

}


int CreateOffscreenBuffers(HWND hWnd, HDC DC){
HDC	hBkGndDC, hBuffDC;

	if (hBmpOffscreenBuffer){
		DeleteObject(hBmpOffscreenBuffer);
	}
	if (hBmpBkGndBuffer){
		DeleteObject(hBmpBkGndBuffer);
	}

	// create temporary hold bitmaps
	hBmpOffscreenBuffer = CreateCompatibleBitmap(DC, ViewPort_Width, ViewPort_Height);
	if (hBmpOffscreenBuffer){
		hBuffDC = CreateCompatibleDC(DC);
		SelectObject(hBuffDC, hBmpOffscreenBuffer);

		// paint the buffer black...
		PatBlt(hBuffDC, 0, 0, ViewPort_Width, ViewPort_Height, BLACKNESS);

	} else {
		return FALSE;
	}
	hBmpBkGndBuffer = CreateCompatibleBitmap(DC, ViewPort_Width, ViewPort_Height);
	if (hBmpBkGndBuffer){
		hBkGndDC = CreateCompatibleDC(DC);
		SelectObject(hBkGndDC, hBmpBkGndBuffer);

		// paint the buffer black...
		PatBlt(hBkGndDC, 0, 0, ViewPort_Width, ViewPort_Height, BLACKNESS);

		// render the starfield
		DrawStarField(hWnd, hBkGndDC);


	} else {
		return FALSE;
	}

	// transfer the starfield buffer to the offscreen buffer
	BitBlt(
		hBuffDC,
		0,
		0,
		ViewPort_Width,
		ViewPort_Height,
		hBkGndDC,
		0,
		0,
		SRCCOPY);

	DeleteDC(hBuffDC);
	DeleteDC(hBkGndDC);

	return TRUE;

}



void ExplodeObject(HWND hWnd, Object2d *objP){
int i;
FLOATPOINT	unitPt, midPt, newPt, fromPt, toPt;
float randDir, length;
Object2d	*p;
BOOL		found;
UINT		debrisNum;


	if (objP->State() == OBJSTATE_EXPLODING){
		// initiate explosion...
		objP->State(OBJSTATE_DESTROYED);
		objP->Visible(FALSE);

		// decompose object into individual lines
		for (i=0; i < (objP->m_numLines); i++){

			// find an unused debris object
			found = FALSE;
			debrisNum = 0;
			while(!found){
				if (debris[debrisNum].Lifetime()==0){
					found = TRUE;
				} else {
					++debrisNum;
				}
			}
			if (!found){ return; } // no debris available!!!
			p = &debris[debrisNum];

			p->m_verts[0] = fromPt = objP->m_verts[ (objP->m_lines[i].x) ];	// from
			p->m_verts[1] = toPt = objP->m_verts[ (objP->m_lines[i].y) ];	// to
			p->m_numVerts = 2;												// one line
			p->m_numLines = 1;
			p->m_lines[0] = MakeIntPoint(0,1);								// line from vertex 0 to vertex 1

			p->Flash(objP->m_flashbright, objP->m_flashtimer);
			p->Brightness(ExplodeSecondaryBrightness);
			p->Rotate(objP->Rotate());
			p->Position(objP->Position());
			p->State(OBJSTATE_NORMAL);
			p->Lifetime(ExplodeLifetime-((ExplodeLifetime*random())/4));
			p->Visible(TRUE);

			// set rotation and direction...
			// get midpoint of the line
			midPt = (fromPt + toPt) / 2;

			// calculate length of midpoint from 0,0
			length =  sqrt((midPt.x * midPt.x) + (midPt.y * midPt.y));

			// divide the vector by it's length -- unit vector
			unitPt.x = (midPt.x / length) * debrisMaxSpeed;
			unitPt.y = (midPt.y / length) * debrisMaxSpeed;

			// send the debris piece in the direction of
			// it's unit vector -- adjust speed randomly
			unitPt -= (random() * debrisMaxSpeed);

			// tweak the direction randomly
			randDir = (random() * (debrisDirectionVar*2)) - (debrisDirectionVar/2);
			randDir += objP->Rotate();
			if (randDir < 0){ randDir += NUMBER_OF_DEGREES; }
			else if (randDir >= NUMBER_OF_DEGREES){ randDir -= NUMBER_OF_DEGREES; }

			// rotate the direction
			newPt = RotatePoint(unitPt, (int)randDir);
		
			// set the direction and speed
			p->Speed(newPt);

			// set the amount of spin
			p->Spin( (random() * (debrisSpinRange*2)) - (debrisSpinRange/2) );

		}

	}


}



void calcSunGravity(Object2d *objP){
float length, xLen, yLen, unitX, unitY;
float mass, gravFactor;
FLOATPOINT objPos, sunPos, speed;

	switch(objP->ObjectID()){
		case OBJID_DEBRIS:
			mass = debrisMass;
			break;
		case OBJID_PLAYER1FRONT:
			mass = shipPlayer1Mass;
			break;
		case OBJID_PLAYER1RIGHT:
		case OBJID_PLAYER1LEFT:
			return;
		case OBJID_PLAYER2FRONT:
			mass = shipPlayer2Mass;
			break;
		case OBJID_PLAYER2RIGHT:
		case OBJID_PLAYER2LEFT:
			return;
		case OBJID_ASTEROID:
			mass = asteroidMass;
			break;
		case OBJID_MISSILE:
			mass = missileMass;
			break;
		default:
			return;
	}

	// calculate gravity for object mass
	if (gameOver && !attractTimer){
		if (attractModeGravInv){
			gravFactor = (-ATTRACTMODE_SUNGRAVITY)/mass;
		} else {
			gravFactor = ATTRACTMODE_SUNGRAVITY/mass;
		}
	} else {
		if (inverseGravity){
			gravFactor = (-SunGravity)/mass;
		} else {
			gravFactor = SunGravity/mass;
		}
	}

	// calculate distance from the sun
	objPos = objP->Position();
	sunPos = sunA.Position();
	xLen = objPos.x - sunPos.x;
	yLen = objPos.y - sunPos.y;
	length =  sqrt((xLen * xLen) + (yLen * yLen));

	// calculate unit vector
	unitX = xLen / length;
	unitY = yLen / length;

	// clamp the distance
	if (length < sunDistClamp){
		length = sunDistClamp;
	}

	// gravity is inverse r squared
	unitX = unitX * (gravFactor/(length*length));
	unitY = unitY * (gravFactor/(length*length));

	// update object speed
	speed = objP->Speed();
	speed.x += unitX;
	speed.y += unitY;
	objP->Speed(speed);

}



void CreateAsteroid(Object2d *objP){
float value;

	
	value = random() * 3;
	switch((int)value){
		case 0:
			// start on left edge...
			objP->Position(MakeFloatPoint(0.0, (random() * (ViewPort_Height/ScreenYScaler))));
			value = random() * 3;
			switch((int)value){
				case 0:
					objP->Speed(MakeFloatPoint(asteroidSpeed, asteroidSpeed));
					break;
				case 1:
					objP->Speed(MakeFloatPoint(asteroidSpeed, -asteroidSpeed));
					break;
				case 2:
					objP->Speed(MakeFloatPoint(asteroidSpeed/2, asteroidSpeed));
					break;
				case 3:
				default:
					objP->Speed(MakeFloatPoint(asteroidSpeed/2, -asteroidSpeed));
					break;
			}
			break;
		case 1:
			// start on top edge...
			objP->Position(MakeFloatPoint((random() * (ViewPort_Width/ScreenXScaler)), 0.0));
			value = random() * 3;
			switch((int)value){
				case 0:
					objP->Speed(MakeFloatPoint(asteroidSpeed, asteroidSpeed));
					break;
				case 1:
					objP->Speed(MakeFloatPoint(-asteroidSpeed, asteroidSpeed));
					break;
				case 2:
					objP->Speed(MakeFloatPoint(asteroidSpeed/2, asteroidSpeed));
					break;
				case 3:
				default:
					objP->Speed(MakeFloatPoint(-asteroidSpeed/2, asteroidSpeed));
					break;
			}
			break;
		case 2:
			// start on right edge...
			objP->Position(MakeFloatPoint((ViewPort_Width/ScreenXScaler),
				(random() * (ViewPort_Height/ScreenYScaler))));
			value = random() * 3;
			switch((int)value){
				case 0:
					objP->Speed(MakeFloatPoint(-asteroidSpeed, asteroidSpeed));
					break;
				case 1:
					objP->Speed(MakeFloatPoint(-asteroidSpeed, -asteroidSpeed));
					break;
				case 2:
					objP->Speed(MakeFloatPoint(-asteroidSpeed/2, asteroidSpeed));
					break;
				case 3:
				default:
					objP->Speed(MakeFloatPoint(-asteroidSpeed/2, -asteroidSpeed));
					break;
			}
			break;
		case 3:
		default:
			// start on bottom edge...
			objP->Position(MakeFloatPoint((random() * (ViewPort_Width/ScreenXScaler)),
				(ViewPort_Height/ScreenYScaler)));
			value = random() * 3;
			switch((int)value){
				case 0:
					objP->Speed(MakeFloatPoint(asteroidSpeed, -asteroidSpeed));
					break;
				case 1:
					objP->Speed(MakeFloatPoint(-asteroidSpeed, -asteroidSpeed));
					break;
				case 2:
					objP->Speed(MakeFloatPoint(asteroidSpeed/2, -asteroidSpeed));
					break;
				case 3:
				default:
					objP->Speed(MakeFloatPoint(-asteroidSpeed/2, -asteroidSpeed));
					break;
			}
			break;
	}

	// start a new asteroid...
	objP->Brightness(asteroidBrightness);
	objP->Visible(TRUE);
	objP->Spin(asteroidRotSpeed);

}


void CollisionCheck(HWND hWnd){
int numMissile;
AREARECT sunRect;
FLOATPOINT fromPt, toPt;
int	i, j;
Object2d *obj1P, *obj2P;
FLOATPOINT scaler;


	// check for game over - "attract mode"
	if (gameOver){ return; }

	scaler = MakeFloatPoint(ScreenXScaler, ScreenYScaler);

	for(i=0; (obj1P = objectList[i]); i++){
		if ((obj1P->Visible() || obj1P->m_eraseMe) && (obj1P->State() < OBJSTATE_DESTROYED)){
			for(j=0; (obj2P = objectList[j]); j++){
				if (obj1P == obj2P){ continue; }
				if ((obj2P->Visible() || obj2P->m_eraseMe) && (obj2P->State() < OBJSTATE_DESTROYED)){
					if (obj1P->ObjectID() == OBJID_MISSILE){
						if (LineRectIntersect((obj1P->m_pos * scaler), (obj1P->m_posOld * scaler), obj2P->m_invRect)){
							// missile hit object
							switch(obj2P->ObjectID()){
								case OBJID_PLAYER1FRONT:
									obj1P->Lifetime(0);
									obj1P->Visible(FALSE);
									InitFatal(shipPlayer1.front);
									InitFatal(shipPlayer1.right);
									InitFatal(shipPlayer1.left);
									break;
								case OBJID_PLAYER1RIGHT:
									obj1P->Lifetime(0);
									obj1P->Visible(FALSE);
									shipPlayer1.shipFlash(damageFlashBrightness, damageFlashTime);
									InitDamage(shipPlayer1.right);
									break;
								case OBJID_PLAYER1LEFT:
									obj1P->Lifetime(0);
									obj1P->Visible(FALSE);
									shipPlayer1.shipFlash(damageFlashBrightness, damageFlashTime);
									InitDamage(shipPlayer1.left);
									break;
								case OBJID_PLAYER2FRONT:
									obj1P->Lifetime(0);
									obj1P->Visible(FALSE);
									InitFatal(shipPlayer2.front);
									InitFatal(shipPlayer2.right);
									InitFatal(shipPlayer2.left);
									break;
								case OBJID_PLAYER2RIGHT:
									obj1P->Lifetime(0);
									obj1P->Visible(FALSE);
									shipPlayer2.shipFlash(damageFlashBrightness, damageFlashTime);
									InitDamage(shipPlayer2.right);
									break;
								case OBJID_PLAYER2LEFT:
									obj1P->Lifetime(0);
									obj1P->Visible(FALSE);
									shipPlayer2.shipFlash(damageFlashBrightness, damageFlashTime);
									InitDamage(shipPlayer2.left);
									break;
								case OBJID_SUNA:
								case OBJID_SUNB:
									if (!SunPresent){ break; }
								case OBJID_ASTEROID:
									obj1P->Lifetime(0);
									obj1P->Visible(FALSE);
									break;
								case OBJID_MISSILE:
									obj1P->Lifetime(0);
									obj1P->Visible(FALSE);
									obj2P->Lifetime(0);
									obj2P->Visible(FALSE);
									break;
							}
						}
					} else {
						if (DoRectsIntersect(obj1P->m_invRect, obj2P->m_invRect)){
							// object hit object
							switch(obj1P->ObjectID()){
								case OBJID_PLAYER1FRONT:
									switch(obj2P->ObjectID()){
										case OBJID_PLAYER2FRONT:
											InitFatal(shipPlayer2.front);
											InitFatal(shipPlayer2.right);
											InitFatal(shipPlayer2.left);
											InitFatal(shipPlayer1.front);
											InitFatal(shipPlayer1.right);
											InitFatal(shipPlayer1.left);
											break;
										case OBJID_SUNA:
										case OBJID_SUNB:
											if (!SunPresent){ break; }
										case OBJID_ASTEROID:
											InitFatal(shipPlayer1.front);
											InitFatal(shipPlayer1.right);
											InitFatal(shipPlayer1.left);
											break;
									}
									break;
								case OBJID_PLAYER1RIGHT:
									switch (obj2P->ObjectID()){
										case OBJID_SUNA:
										case OBJID_SUNB:
											if (!SunPresent){ break; }
											InitFatal(shipPlayer1.front);
											InitFatal(shipPlayer1.right);
											InitFatal(shipPlayer1.left);
											break;
										case OBJID_PLAYER2FRONT:
										case OBJID_PLAYER2RIGHT:
										case OBJID_PLAYER2LEFT:
										case OBJID_ASTEROID:
											shipPlayer1.shipFlash(damageFlashBrightness, damageFlashTime);
											InitDamage(shipPlayer1.right);
											break;
									}
									break;
								case OBJID_PLAYER1LEFT:
									switch (obj2P->ObjectID()){
										case OBJID_SUNA:
										case OBJID_SUNB:
											if (!SunPresent){ break; }
											InitFatal(shipPlayer1.front);
											InitFatal(shipPlayer1.right);
											InitFatal(shipPlayer1.left);
											break;
										case OBJID_PLAYER2FRONT:
										case OBJID_PLAYER2RIGHT:
										case OBJID_PLAYER2LEFT:
										case OBJID_ASTEROID:
											shipPlayer1.shipFlash(damageFlashBrightness, damageFlashTime);
											InitDamage(shipPlayer1.left);
											break;
									}
									break;
								case OBJID_PLAYER2FRONT:
									switch(obj2P->ObjectID()){
										case OBJID_PLAYER2FRONT:
											InitFatal(shipPlayer1.front);
											InitFatal(shipPlayer1.right);
											InitFatal(shipPlayer1.left);
											InitFatal(shipPlayer2.front);
											InitFatal(shipPlayer2.right);
											InitFatal(shipPlayer2.left);
											break;
										case OBJID_SUNA:
										case OBJID_SUNB:
											if (!SunPresent){ break; }
										case OBJID_ASTEROID:
											InitFatal(shipPlayer2.front);
											InitFatal(shipPlayer2.right);
											InitFatal(shipPlayer2.left);
											break;
									}
									break;
								case OBJID_PLAYER2RIGHT:
									switch (obj2P->ObjectID()){
										case OBJID_SUNA:
										case OBJID_SUNB:
											if (!SunPresent){ break; }
											InitFatal(shipPlayer2.front);
											InitFatal(shipPlayer2.right);
											InitFatal(shipPlayer2.left);
											break;
										case OBJID_PLAYER1FRONT:
										case OBJID_PLAYER1RIGHT:
										case OBJID_PLAYER1LEFT:
										case OBJID_ASTEROID:
											shipPlayer2.shipFlash(damageFlashBrightness, damageFlashTime);
											InitDamage(shipPlayer2.right);
											break;
									}
									break;
								case OBJID_PLAYER2LEFT:
									switch (obj2P->ObjectID()){
										case OBJID_SUNA:
										case OBJID_SUNB:
											if (!SunPresent){ break; }
											InitFatal(shipPlayer2.front);
											InitFatal(shipPlayer2.right);
											InitFatal(shipPlayer2.left);
											break;
										case OBJID_PLAYER1FRONT:
										case OBJID_PLAYER1RIGHT:
										case OBJID_PLAYER1LEFT:
										case OBJID_ASTEROID:
											shipPlayer2.shipFlash(damageFlashBrightness, damageFlashTime);
											InitDamage(shipPlayer2.left);
											break;
									}
									break;

							}
						}

					}

				}
			}
		}
	}

}


void InitDamage(Object2d *objP){
	if (objP->State() == OBJSTATE_NORMAL){
		objP->State(OBJSTATE_EXPLODING);
		ExplodeObject(NULL, objP);
	}
}


void InitFatal(Object2d *objP){
	if (objP->State() == OBJSTATE_NORMAL){
		objP->Speed(MakeFloatPoint(0.0, 0.0));
		objP->Lifetime(ExplodePausetime);
		objP->State(OBJSTATE_EXPLODING);
		objP->Brightness(ExplodeInitialBrightness);
	}
}


void OnRoundEnd(HWND hWnd){
	OnRoundStart(hWnd);
}


void OnGameEnd(HWND hWnd){

	// stop the music
//	stopWAV();

	keyPlayer1Thrust=FALSE;
	keyPlayer2Thrust=FALSE;
	attractTimer = attractTime;
	attractModeGravTimer = attractModeGravTime;
	roundTime=0;
	gameOver=TRUE;
	gameoverObj.Visible(TRUE);
}

